unit bcBenchcheck;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, ECEditBtns, ECSwitch, TreeListView,
  DateTimePicker, cyAdvLed, cyBevel, cySpeedButton, cyAdvSpeedButton, ueled,
  AdvLed, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, windows,
  messages, lcltype, ComCtrls, DBGrids, Calendar, EditBtn, ExtDlgs, dateutils, Types, InterfaceBase;

type

  { TBenchcheckForm }

  TBenchcheckForm = class(TForm)
    AddConButton: TECSpeedBtn;
    Bevel1: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel2: TBevel;
    Checkbox10: TcyAdvLed;
    Checkbox11: TcyAdvLed;
    Checkbox4: TcyAdvLed;
    Checkbox5: TcyAdvLed;
    Checkbox6: TcyAdvLed;
    Checkbox7: TcyAdvLed;
    Checkbox8: TcyAdvLed;
    Checkbox9: TcyAdvLed;
    CloseButton: TECSpeedBtn;
    Checkbox1: TcyAdvLed;
    AddToolButton: TECSpeedBtn;
    Checkbox2: TcyAdvLed;
    Checkbox3: TcyAdvLed;
    CalReqCheckbox: TcyAdvLed;
    Label23: TLabel;
    ToolStartDateCombo: TDateTimePicker;
    Label28: TLabel;
    Label29: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    ToolSetCombo: TComboBox;
    ToolRefEdit: TEdit;
    ToolExpDateCombo: TDateTimePicker;
    ToolTypeCombo: TComboBox;
    DeleteToolButton: TECSpeedBtn;
    DeleteConButton: TECSpeedBtn;
    EditToolButton: TECSpeedBtn;
    EditConButton: TECSpeedBtn;
    Label10: TLabel;
    Label11: TLabel;
    ExtLabel: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    EOSTitleLabel: TLabel;
    EOSPromptLabel: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    ToolRecordTitleLabel: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ConErrorLabel: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    CompletePromptLabel: TLabel;
    StratShiftPage3: TTabSheet;
    StartShiftPage4: TTabSheet;
    StartShiftPage5: TTabSheet;
    EndShiftPage: TTabSheet;
    BenchcheckCompletePage: TTabSheet;
    ToolRecordPage: TTabSheet;
    ToolsErrorLabel: TLabel;
    PrevButton: TECSpeedBtn;
    Image1: TImage;
    Label1: TLabel;
    ToolsTree: TTreeListView;
    ConTree: TTreeListView;
    ToolDesCombo: TComboBox;
    WelcomeLabel: TLabel;
    StartLabel: TLabel;
    ToolsLabel: TLabel;
    PageControl: TPageControl;
    Panel1: TPanel;
    StartShiftPage1: TTabSheet;
    StartShiftPage2: TTabSheet;
    CompleteTitleLabel: TLabel;
    procedure AddConButtonMouseLeave(Sender: TObject);
    procedure AddConButtonMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AddToolButtonClick(Sender: TObject);
    procedure AddToolButtonMouseLeave(Sender: TObject);
    procedure Checkbox10Click(Sender: TObject);
    procedure Checkbox11Click(Sender: TObject);
    procedure Checkbox1Click(Sender: TObject);
    procedure AddToolButtonMouseEnter(Sender: TObject);
    procedure Checkbox2Click(Sender: TObject);
    procedure Checkbox3Click(Sender: TObject);
    procedure Checkbox4Click(Sender: TObject);
    procedure Checkbox5Click(Sender: TObject);
    procedure Checkbox6Click(Sender: TObject);
    procedure Checkbox7Click(Sender: TObject);
    procedure Checkbox8Click(Sender: TObject);
    procedure Checkbox9Click(Sender: TObject);
    procedure ConTreeClickAtItem(sender: TObject; item: TTreeListItem);
    procedure CalReqCheckboxClick(Sender: TObject);
    procedure DeleteConButtonClick(Sender: TObject);
    procedure DeleteConButtonMouseEnter(Sender: TObject);
    procedure DeleteConButtonMouseLeave(Sender: TObject);
    procedure DeleteToolButtonClick(Sender: TObject);
    procedure DeleteToolButtonMouseEnter(Sender: TObject);
    procedure DeleteToolButtonMouseLeave(Sender: TObject);
    procedure EditConButtonMouseEnter(Sender: TObject);
    procedure EditConButtonMouseLeave(Sender: TObject);
    procedure EditToolButtonClick(Sender: TObject);
    procedure EditToolButtonMouseEnter(Sender: TObject);
    procedure EditToolButtonMouseLeave(Sender: TObject);
    procedure ExtLabelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure Label10Click(Sender: TObject);
    procedure Label15Click(Sender: TObject);
    procedure Label17Click(Sender: TObject);
    procedure Label19Click(Sender: TObject);
    procedure Label21Click(Sender: TObject);
    procedure Label27Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure Label7Click(Sender: TObject);
    procedure Label8Click(Sender: TObject);
    procedure PrevButtonClick(Sender: TObject);
    procedure PrevButtonMouseLeave(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure CloseButtonMouseEnter(Sender: TObject);
    procedure CloseButtonMouseLeave(Sender: TObject);
    procedure PrevButtonMouseEnter(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StartShiftPage2ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure ToolDesComboChange(Sender: TObject);
    procedure ToolDesComboKeyPress(Sender: TObject; var Key: char);
    procedure ToolExpDateComboChange(Sender: TObject);
    procedure ToolRefEditKeyPress(Sender: TObject; var Key: char);
    procedure ToolSetComboChange(Sender: TObject);
    procedure ToolSetComboKeyPress(Sender: TObject; var Key: char);
    procedure ToolStartDateComboChange(Sender: TObject);
    procedure ToolsTreeClickAtItem(sender: TObject; item: TTreeListItem);
    procedure ToolTypeComboChange(Sender: TObject);
    procedure ToolTypeComboKeyPress(Sender: TObject; var Key: char);
  private
    { private declarations }
  public
    { public declarations }
    procedure CreateParams(var Params: TCreateParams); override;

    procedure GetToolsInformation;
    procedure GetConInformation;
    procedure PostStartOfShiftData;
    procedure PostEndOfShiftData;
    procedure PostToolRecord;
    procedure UpdateToolRecord;
    procedure ToggleLED(LED: TcyAdvLED);
    procedure DeleteToolItem;
    procedure DeleteConsItem;
    procedure StartNewToolRecord;
    procedure StartUpdateToolRecord;

    function GetExtractionID: string;
  end;

{Global benchcheck form launch routine.}


var
  BenchcheckForm: TBenchcheckForm;

implementation

{$R *.lfm}

uses
    bcconstants, bcoptions, bcmain, approutines, greyscreen;


{ TBenchcheckForm }

procedure TBenchcheckForm.FormShow(Sender: TObject);
begin
     {Set form caption and version info label.}
     Caption := Application.Title + BenchCheckTitle;
     Label1.Caption := 'Version ' + GetAppVersionStr(WorkbenchEXE);
     {Highlight form if grey screen enabled.}
     UpdateGreyScreen(BenchcheckForm);
     {Welcome user.}
     WelcomeLabel.Caption := 'Welcome ' + Workbench.Firstname;
     StartLabel.Caption := 'Please take a moment to complete your start of shift' +
                         #13#10 + ' check list for workbench ' + Workbench.BenchName;

     {Set extraction label.}
     ExtLabel.Caption := 'Is local extraction unit ' + GetExtractionID + ' working correctly and' + #13#10 +
                            'the monthly maintenance has been completed?';
     {Load tool database information.}
     GetToolsInformation;
     {Load consumables information.}
     GetConInformation;
     {Disable edit and delete item buttons.}
     EditToolButton.Enabled := false;
     DeleteToolButton.Enabled := false;
     EditConButton.Enabled := false;
     DeleteConButton.Enabled := false;
     {Set end of shift labels.}
     EOSTitleLabel.Caption := 'Welcome back ' + Workbench.Firstname;
     EOSPromptLabel.Caption := 'Please complete your daily check list for workbench ' + Workbench.BenchName;
     {Set benchcheck complete labels.}
     CompleteTitleLabel.Caption := Workbench.Firstname;
     CompletePromptLabel.Caption := 'You have already completed todays daily benchcheck ' + #13#10 +
                                    'list for workbench ' + Workbench.BenchName;
end;

procedure TBenchcheckForm.StartShiftPage2ContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure TBenchcheckForm.ToolRefEditKeyPress(Sender: TObject; var Key: char);
begin
     if Key = #13 then begin
        {Stop beep.}
        Key := #0;
        ToolRecord.ToolID := UpperCase(ToolRefEdit.Text);
        ToolRefEdit.Text := ToolRecord.ToolID;
        {Load tool type list into combobox.}
        ToolRecord.GetToolTypeList(ToolTypeCombo.Items);
        ToolTypeCombo.Enabled := true;
        ToolTypeCombo.SetFocus;
     end;
end; 

procedure TBenchcheckForm.ToolTypeComboChange(Sender: TObject);
begin
     ToolRecord.ToolType := UpperCaseFirstChar(ToolTypeCombo.Text);
     ToolTypeCombo.Text := ToolRecord.ToolType;
     ToolTypeCombo.SelStart := Length(ToolTypeCombo.Text);
end;

procedure TBenchcheckForm.ToolTypeComboKeyPress(Sender: TObject; var Key: char);
begin
     if Key = #13 then begin
        {Stop beep.}
        Key := #0;

        ToolRecord.ToolType := UpperCaseFirstChar(ToolTypeCombo.Text);
        ToolTypeCombo.Text := ToolRecord.ToolType;
        ToolTypeCombo.SelStart := Length(ToolTypeCombo.Text);
        {Load tool type list into combobox.}
        ToolRecord.GetToolDescriptionList(ToolDesCombo.Items);
        ToolDesCombo.Enabled := true;
        ToolDesCombo.SetFocus;
     end;
end;

procedure TBenchcheckForm.ToolDesComboChange(Sender: TObject);
begin
     ToolRecord.ToolDescription := UpperCaseFirstChar(ToolDesCombo.Text);
     ToolDesCombo.Text := ToolRecord.ToolDescription;
     ToolDesCombo.SelStart := Length(ToolDesCombo.Text);
end;

procedure TBenchcheckForm.ToolDesComboKeyPress(Sender: TObject; var Key: char);
begin
     if Key = #13 then begin
        {Stop beep.}
        Key := #0;
        ToolRecord.ToolDescription := UpperCaseFirstChar(ToolDesCombo.Text);
        ToolDesCombo.Text := ToolRecord.ToolDescription; 
        ToolDesCombo.SelStart := Length(ToolDesCombo.Text);
        {Load tool type list into combobox.}
        ToolRecord.GetToolSetting(ToolSetCombo.Items);
        ToolSetCombo.Enabled := true;
        ToolSetCombo.SetFocus;
     end;
end;

procedure TBenchcheckForm.ToolSetComboChange(Sender: TObject);
begin
     ToolRecord.ToolSetting := UpperCaseFirstChar(ToolSetCombo.Text);
     ToolSetCombo.Text := ToolRecord.ToolSetting;
     ToolSetCombo.SelStart := Length(ToolSetCombo.Text);
end;

procedure TBenchcheckForm.ToolSetComboKeyPress(Sender: TObject; var Key: char);
begin
     if Key = #13 then begin
        {Stop beep.}
        Key := #0;

        ToolRecord.ToolSetting := UpperCaseFirstChar(ToolSetCombo.Text);
        ToolSetCombo.Text := ToolRecord.ToolSetting;
        label23.caption := toolrecord.ToolSetting;
        ToolSetCombo.SelStart := Length(ToolSetCombo.Text);
        CalReqCheckbox.Enabled := true;
     end;
end;

procedure TBenchcheckForm.ToolExpDateComboChange(Sender: TObject);
begin
     ToolRecord.ToolExpDate := ToolExpDateCombo.Date;
end;

procedure TBenchcheckForm.ToolStartDateComboChange(Sender: TObject);
begin
     ToolRecord.ToolCalDate := ToolStartDateCombo.Date;
end;

procedure TBenchcheckForm.ToolsTreeClickAtItem(sender: TObject;
  item: TTreeListItem);
begin
     {Enable edit and delete buttons.}
     EditToolButton.Enabled := true;
     DeleteToolButton.Enabled := true;
end;

procedure TBenchcheckForm.CreateParams(var Params: TCreateParams);
begin
     inherited CreateParams(Params);
     Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
end;

procedure TBenchcheckForm.CloseButtonMouseEnter(Sender: TObject);
begin
     if CloseButton.ImageIndex = 0 then CloseButton.ImageIndex := 1;
     if CloseButton.ImageIndex = 14 then CloseButton.ImageIndex := 15;
end;

procedure TBenchcheckForm.CloseButtonClick(Sender: TObject);
begin

     if (CloseButton.ImageIndex = 0) or (CloseButton.ImageIndex = 1) then begin
        {Post start of shift data to database.}
        if Pagecontrol.PageIndex = 4 then begin
           PostStartOfShiftData;
           {Block windows shutdown.}
           if Settings.BlockWindowsIndex = 0 then
              Settings.BlockShutdown := true;
           close
        end;
        {Post end of shift data to database.}
        if Pagecontrol.PageIndex = 5 then begin
           PostEndOfShiftData;
           {UnBlock windows shutdown.}
           if Settings.BlockWindowsIndex = 0 then begin
              Settings.BlockShutdown := false;
              ShutdownBlockReasonDestroy(WidgetSet.AppHandle);
           end;
           close;
        end;
        if Pagecontrol.PageIndex = 7 then begin
           PageControl.PageIndex := 1;
           CloseButton.ImageIndex := 14;
           {Post tool record to database.}
           if ToolRecord.NewTool then
              PostToolRecord
           else
              UpdateToolRecord;
           {Set close and previous buttons.}
           CloseButton.Hint:= 'Next page.';
           PrevButton.Hint := 'Previous page.';
           PrevButton.ImageIndex := 16;
           PrevButton.Show;
           PrevButton.Enabled := true;
           ToolRecord.Free;
        end;
     end
     else
     if Pagecontrol.PageIndex < (Pagecontrol.PageCount - 1) then begin
        Pagecontrol.TabIndex := Pagecontrol.TabIndex + 1;
        PrevButton.Enabled := true;
     end;
     If Pagecontrol.PageIndex = 4 then begin
        CloseButton.Hint := 'Close.';
        CloseButton.ImageIndex := 0;
     end;
     If (Pagecontrol.PageIndex = 5) or (Pagecontrol.PageIndex = 6) then begin
        CloseButton.Hint := 'Close.';
        CloseButton.ImageIndex := 0;
        PrevButton.Hide;
     end;
     If Pagecontrol.PageIndex = 7 then begin
        CloseButton.Hint := 'Close.';
        CloseButton.ImageIndex := 0;
        PrevButton.Hint := 'Cancel';
        PrevButton.ImageIndex := 12;
        PrevButton.Show;
     end;
     {Hide edit fields.}
     ToolRefEdit.Hide;
     ToolTypeCombo.Hide;
     ToolDesCombo.Hide;
     ToolSetCombo.Hide;
     ToolStartDateCombo.Hide;
     ToolExpDateCombo.Hide;
end;

procedure TBenchcheckForm.PrevButtonMouseLeave(Sender: TObject);
begin
     if PrevButton.ImageIndex = 17 then PrevButton.ImageIndex := 16;
     if PrevButton.ImageIndex = 13 then PrevButton.ImageIndex := 12;
end;

procedure TBenchcheckForm.PrevButtonClick(Sender: TObject);
begin
     PrevButton.Enabled := false;
     if (PrevButton.ImageIndex = 16) or (PrevButton.ImageIndex = 17) then begin
        Pagecontrol.TabIndex := pagecontrol.TabIndex - 1;
        if Pagecontrol.PageIndex In [1..4] then begin
           PrevButton.Enabled := true;
        end
        else
            PrevButton.Enabled := false;
        CloseButton.ImageIndex := 14;
     end;
     if (PrevButton.ImageIndex = 12) or (PrevButton.ImageIndex = 13) then begin
        if Pagecontrol.PageIndex = 7 then begin
           PageControl.PageIndex := 1;
           CloseButton.ImageIndex := 14;
           CloseButton.Hint:= 'Next page.';
           PrevButton.Hint := 'Previous page.';
           PrevButton.ImageIndex := 16;
           PrevButton.Show;
           PrevButton.Enabled := true;
           ToolRecord.Free;
        end;
     end;
     {Hide edit fields.}
     ToolRefEdit.Hide;
     ToolTypeCombo.Hide;
     ToolDesCombo.Hide;
     ToolSetCombo.Hide;
     ToolStartDateCombo.Hide;
     ToolExpDateCombo.Hide;
end;

procedure TBenchcheckForm.Checkbox1Click(Sender: TObject);
begin
     Workbench.ToolsConfirmed := Checkbox1.LedValue;
end;

procedure TBenchcheckForm.AddToolButtonMouseLeave(Sender: TObject);
begin
     AddToolButton.ImageIndex := 0;
end;

procedure TBenchcheckForm.Checkbox10Click(Sender: TObject);
begin
     Workbench.EOSTimecard := Checkbox10.LedValue;
end;

procedure TBenchcheckForm.Checkbox11Click(Sender: TObject);
begin
     Workbench.EOSEquipmentOff := Checkbox11.LedValue;
end;

procedure TBenchcheckForm.AddConButtonMouseLeave(Sender: TObject);
begin
     AddConButton.ImageIndex := 1;
end;

procedure TBenchcheckForm.AddConButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     AddConButton.ImageIndex := 0;
end;

procedure TBenchcheckForm.AddToolButtonClick(Sender: TObject);
begin
     ToolRecordTitleLabel.Caption := 'Please enter details of the new item of equipment or tooling ' +
                            #10#13 + 'to be assigned to workbench ' + Workbench.BenchName;
     {Show tool recoed page.}
     Pagecontrol.ActivePage := ToolRecordPage;
     {Set close button to ok.}
     PageControl.PageIndex := 7;
     CloseButton.ImageIndex := 0;
     CloseButton.Hint:= 'OK.';
     {Change previous page button to cancel button.}
     PrevButton.Hint := 'Cancel.';
     PrevButton.ImageIndex := 12;
     PrevButton.Show;
     PrevButton.Enabled := true;
     {Populate clear edit fields.}
     StartNewToolRecord;
end;

procedure TBenchcheckForm.AddToolButtonMouseEnter(Sender: TObject);
begin
     AddToolButton.ImageIndex := 1;
end;

procedure TBenchcheckForm.Checkbox2Click(Sender: TObject);
begin
     Workbench.ConsumablesConfirmed := Checkbox2.LedValue;
end;

procedure TBenchcheckForm.Checkbox3Click(Sender: TObject);
begin
     Workbench.ESDStrapsConfirmed := Checkbox3.LedValue;
end;

procedure TBenchcheckForm.Checkbox4Click(Sender: TObject);
begin
     Workbench.ESDBenchConfirmed := Checkbox4.LedValue;
end;

procedure TBenchcheckForm.Checkbox5Click(Sender: TObject);
begin
     Workbench.ESDJacketConfirmed := Checkbox5.LedValue;
end;

procedure TBenchcheckForm.Checkbox6Click(Sender: TObject);
begin
     Workbench.StartFODConfirmed := Checkbox6.LedValue;
end;

procedure TBenchcheckForm.Checkbox7Click(Sender: TObject);
begin
     Workbench.ExtractionConfirmed := Checkbox7.LedValue;
end;

procedure TBenchcheckForm.Checkbox8Click(Sender: TObject);
begin
     Workbench.EOSWIP := Checkbox8.LedValue;
end;

procedure TBenchcheckForm.Checkbox9Click(Sender: TObject);
begin
     Workbench.EOSFODConfirmed := Checkbox9.LedValue;
end;

procedure TBenchcheckForm.ConTreeClickAtItem(sender: TObject;
  item: TTreeListItem);
begin
     {Enable consumable edit and delete buttons.}
     EditConButton.Enabled := true;
     DeleteConButton.Enabled := true;
end;

procedure TBenchcheckForm.CalReqCheckboxClick(Sender: TObject);
begin
     ToolRecord.ToolCalRequired := CalReqCheckbox.LedValue;
     if CalReqCheckbox.LedValue then begin
        ToolStartDateCombo.TextForNullDate := 'Select date';
        ToolExpDateCombo.TextForNullDate := 'Select date';
        {Restore dates.}
        ToolRecord.ToolCalDate := ToolRecord.PrevCalDate;
        ToolRecord.ToolExpDate := ToolRecord.PrevExpDate;
        if ToolRecord.ToolCalDate <> 0 then
           ToolStartDateCombo.DateTime := ToolRecord.ToolCalDate
        else
            SendMessageW (ToolStartDateCombo.Handle, WM_KEYDOWN, VK_N, 0);
        if ToolRecord.ToolExpDate <> 0 then
           ToolExpDateCombo.DateTime := ToolRecord.ToolExpDate
        else
          SendMessageW (ToolExpDateCombo.Handle, WM_KEYDOWN, VK_N, 0);
     end
     else
     begin
          ToolStartDateCombo.TextForNullDate := 'Not calibrated';
          ToolExpDateCombo.TextForNullDate := 'Not calibrated';
          {Backup current dates.}
          ToolRecord.PrevCalDate := ToolRecord.ToolCalDate;
          ToolRecord.PrevExpDate := ToolRecord.ToolExpDate;
          {Simulate 'N' keypress to date comboboxes.}
          SendMessageW (ToolStartDateCombo.Handle, WM_KEYDOWN, VK_N, 0);
          SendMessageW (ToolExpDateCombo.Handle, WM_KEYDOWN, VK_N, 0);
          {Set tool record dates to null.}
          ToolRecord.ToolCalDate := NULLDATE;
          ToolRecord.ToolExpDate := NULLDATE;
     end;
     ToolStartDateCombo.Enabled  := CalReqCheckbox.LedValue;
     ToolExpDateCombo.Enabled    := CalReqCheckbox.LedValue;
end;

procedure TBenchcheckForm.DeleteConButtonClick(Sender: TObject);
begin
     {Display item deletion confirmation dialog.}
     if MessageDlg ('Confirmation', 'Do you wish to delete this item from the database?', mtWarning,
                  [mbYes, mbNo],0) = mrYes
     then
         DeleteConsItem;
end;

procedure TBenchcheckForm.DeleteConButtonMouseEnter(Sender: TObject);
begin
     DeleteConButton.ImageIndex := 5;
end;

procedure TBenchcheckForm.DeleteConButtonMouseLeave(Sender: TObject);
begin
     DeleteConButton.ImageIndex := 4;
end;

procedure TBenchcheckForm.DeleteToolButtonClick(Sender: TObject);
begin
     {Display item deletion confirmation dialog.}
     if MessageDlg ('Confirmation', 'Do you wish to delete this item from the database?', mtWarning,
                  [mbYes, mbNo],0) = mrYes
     then
         DeleteToolItem;
end;

procedure TBenchcheckForm.DeleteToolButtonMouseEnter(Sender: TObject);
begin
     DeleteToolButton.ImageIndex := 5;
end;

procedure TBenchcheckForm.DeleteToolButtonMouseLeave(Sender: TObject);
begin
     DeleteToolButton.ImageIndex := 4;
end;

procedure TBenchcheckForm.EditConButtonMouseEnter(Sender: TObject);
begin
     EditConButton.ImageIndex := 3;
end;

procedure TBenchcheckForm.EditConButtonMouseLeave(Sender: TObject);
begin
     EditConButton.ImageIndex := 2;
end;

procedure TBenchcheckForm.EditToolButtonClick(Sender: TObject);
begin
     ToolRecordTitleLabel.Caption := #10#13 + 'Please update the tool or equipment properties as required';
     {Show tool recoed page.}
     Pagecontrol.ActivePage := ToolRecordPage;
     {Set close button to ok.}
     PageControl.PageIndex := 7;
     CloseButton.ImageIndex := 0;
     CloseButton.Hint:= 'OK.';
     {Change previous page button to cancel button.}
     PrevButton.Hint := 'Cancel.';
     PrevButton.ImageIndex := 12;
     PrevButton.Show;
     PrevButton.Enabled := true;
     {Populate clear edit fields.}
     StartUpdateToolRecord;
end;

procedure TBenchcheckForm.EditToolButtonMouseEnter(Sender: TObject);
begin
     EditToolButton.ImageIndex := 3;
end;

procedure TBenchcheckForm.EditToolButtonMouseLeave(Sender: TObject);
begin
     EditToolButton.ImageIndex := 2;
end;

procedure TBenchcheckForm.ExtLabelClick(Sender: TObject);
begin
     ToggleLED(Checkbox7);
     Workbench.ExtractionConfirmed := Checkbox7.LedValue;
end;

procedure TBenchcheckForm.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
     ClearDesktop;
     {Hide edit fields.}
     ToolRefEdit.Hide;
     ToolTypeCombo.Hide;
     ToolDesCombo.Hide;
     ToolSetCombo.Hide;
     ToolStartDateCombo.Hide;
     ToolExpDateCombo.Hide;
end;

procedure TBenchcheckForm.Label10Click(Sender: TObject);
begin
     ToggleLED(Checkbox6);
     Workbench.StartFODConfirmed := Checkbox6.LedValue;
end;

procedure TBenchcheckForm.Label15Click(Sender: TObject);
begin
     ToggleLED(Checkbox8);
     Workbench.EOSWIP := Checkbox8.LedValue;
end;

procedure TBenchcheckForm.Label17Click(Sender: TObject);
begin
     ToggleLED(Checkbox9);
     Workbench.EOSFODConfirmed := Checkbox9.LedValue;
end;

procedure TBenchcheckForm.Label19Click(Sender: TObject);
begin
     ToggleLED(Checkbox10);
     Workbench.EOSTimecard := Checkbox10.LedValue;
end;

procedure TBenchcheckForm.Label21Click(Sender: TObject);
begin
     ToggleLED(Checkbox11);
     Workbench.EOSEquipmentOff := Checkbox11.LedValue;
end;

procedure TBenchcheckForm.Label27Click(Sender: TObject);
begin
     ToggleLED(CalReqCheckbox);
     ToolRecord.ToolCalRequired := CalReqCheckbox.LedValue;
     ToolStartDateCombo.Enabled := CalReqCheckbox.LedValue;
     ToolExpDateCombo.Enabled   := CalReqCheckbox.LedValue;
end;

procedure TBenchcheckForm.Label2Click(Sender: TObject);
begin
     ToggleLED(Checkbox1);
     Workbench.ToolsConfirmed := Checkbox1.LedValue;
end;

procedure TBenchcheckForm.Label3Click(Sender: TObject);
begin
     ToggleLED(Checkbox3);
     Workbench.ESDStrapsConfirmed := Checkbox3.LedValue;
end;

procedure TBenchcheckForm.Label6Click(Sender: TObject);
begin
     ToggleLED(Checkbox2);
     Workbench.ConsumablesConfirmed := Checkbox2.LedValue;
end;

procedure TBenchcheckForm.Label7Click(Sender: TObject);
begin
     ToggleLED(Checkbox4);
     Workbench.ESDBenchConfirmed := Checkbox4.LedValue;
end;

procedure TBenchcheckForm.Label8Click(Sender: TObject);
begin
     ToggleLED(Checkbox5);
     Workbench.ESDJacketConfirmed := Checkbox5.LedValue;
end;

procedure TBenchcheckForm.CloseButtonMouseLeave(Sender: TObject);
begin
     if CloseButton.ImageIndex = 1 then CloseButton.ImageIndex := 0;
     if CloseButton.ImageIndex = 15 then CloseButton.ImageIndex := 14;
end;

procedure TBenchcheckForm.PrevButtonMouseEnter(Sender: TObject);
begin
     if PrevButton.ImageIndex = 16 then PrevButton.ImageIndex := 17;
     if PrevButton.ImageIndex = 12 then PrevButton.ImageIndex := 13;
end;

{Load tool tree from database.}
procedure TBenchcheckForm.GetToolsInformation;
var
   tool_root : array of TTreeListItem;
   i         : integer;
begin
     {Begin tree update.}
     ToolsTree.BeginUpdate;
     {Clear tools tree.}
     ToolsTree.Items.Clear;
     {Clear tools error label.}
     ToolsErrorLabel.Caption := '';

     {Create tools register database object.}
     if CreateToolsDatabaseConnection(self) then begin
        {Set SQL search parameters and run query.}
        ToolsQuery.Close;
        ToolsQuery.SQL.Text := QSearchForWorbenchenchTools;
        ToolsQuery.ParamByName('loc').AsString := Workbench.BenchName;
        ToolsQuery.Open;
        {Check record count and display items.}
        if ToolsQuery.EOF then begin
           ToolsErrorLabel.Caption := 'No records found for this workbench.';
           CloseToolsConnection;
        end else
        begin
             Setlength(tool_root, ToolsQuery.RecordCount - 1);
             {Move to first record.}
             ToolsQuery.First;
             {Create root node for each record and add populate record items.}
             for i := 0 to ToolsQuery.RecordCount - 1 do begin
                  tool_root[i] := ToolsTree.Items.Add(
                        ToolsQuery.FieldByName('ToolID').AsString);
                  tool_root[i].RecordItems.Add(ToolsQuery.FieldByName('Description').AsString);
                  tool_root[i].RecordItems.Add(ToolsQuery.FieldByName('Setting').AsString);
                  {Add dates to tools that requrire calibration.}
                  if ToolsQuery.FieldByName('Calibrated').AsBoolean then begin
                     tool_root[i].RecordItems.Add(FormatDateTime('D/MM/YYYY', ToolsQuery.FieldByName('CalDate').AsDateTime));
                     tool_root[i].RecordItems.Add(FormatDateTime('D/MM/YYYY', ToolsQuery.FieldByName('DueDate').AsDateTime));

                     if CompareDate(now, ToolsQuery.FieldByName('DueDate').AsDateTime) > 0 then begin
                        tool_root[i].ImageIndex := st_bad;
                        ToolsErrorLabel.Caption := 'One or more items require immediate calibration, ' +
                                                           'contact your cell leader.';
                     end
                     else begin
                         if CompareDate(now, IncDay(ToolsQuery.FieldByName('DueDate').AsDateTime,
                                             -(Workbench.CalibrationPrompt + 1))) > 0 then begin
                            tool_root[i].ImageIndex := st_error;
                            ToolsErrorLabel.Caption := 'One or more items are nearing there calibration due date, ' +
                                                            'contact your cell leader.';
                         end
                         else
                             tool_root[i].ImageIndex := st_good;
                     end;

                  end else begin
                      tool_root[i].RecordItems.Add('Not calibrated');
                      tool_root[i].RecordItems.Add('Not calibrated');
                      tool_root[i].ImageIndex := st_good;
                  end;
                  ToolsQuery.Next;
             end;
        end;
        CloseToolsConnection;
     end;
     {Finally close database.}
     {End tree update.}
     ToolsTree.EndUpdate;
end;

{Populate consumables list from database.}
procedure TBenchcheckForm.GetConInformation;
var
   con_root  : array of TTreeListItem;
   i         : integer;
begin
     {Begin tree update.}
     ConTree.BeginUpdate;
     {Clear consumable tree items.}
     ConTree.Items.Clear;
     {Clear tools error label.}
     ConErrorLabel.Caption := '';

     {Create tools register database object.}
     if CreateWorkbenchDatabaseConnection(self) then begin
        {Set SQL search parameters and run query.}
        WorkbenchQuery.Close;
        WorkbenchQuery.SQL.Text := QSearchForWorkbenchConsumables;
        WorkbenchQuery.ParamByName('loc').AsString := Workbench.BenchName;
        WorkbenchQuery.Open;
        {Check record count and display items.}
        if WorkbenchQuery.RecordCount > 0 then
        begin
             Setlength(con_root, WorkbenchQuery.RecordCount - 1);
             {Move to first record.}
             WorkbenchQuery.First;
             {Create root node for each record and add populate record items.}
             for i := 0 to WorkbenchQuery.RecordCount - 1 do begin
                 con_root[i] := ConTree.Items.Add(WorkbenchQuery.FieldByName('PartNumber').AsString);
                 con_root[i].RecordItems.Add(WorkbenchQuery.FieldByName('Description').AsString);
                 con_root[i].RecordItems.Add(IntToStr(WorkbenchQuery.FieldByName('BatchNumber').AsInteger));
                 if WorkbenchQuery.FieldByName('Expires').AsBoolean then begin
                    con_root[i].RecordItems.Add(FormatDateTime('D/MM/YYYY', WorkbenchQuery.FieldByName('ExpiryDate').AsDateTime));

                    if CompareDate(now, WorkbenchQuery.FieldByName('ExpiryDate').AsDateTime) > 0 then begin
                        con_root[i].ImageIndex := st_bad;
                        ConErrorLabel.Caption := 'One or more items has exceeded there expiration date, ' +
                                                 'dispose of items correctly and replace as nessesary.';
                    end
                    else begin
                         if CompareDate(now, IncDay(WorkbenchQuery.FieldByName('ExpiryDate').AsDateTime,
                                             -(Workbench.CalibrationPrompt + 1))) > 0 then begin
                            con_root[i].ImageIndex := st_error;
                            ConErrorLabel.Caption := 'One or more items are nearing there expiration date, ' +
                                                     'dispose of items correctly and replace as nessesary. ';
                         end
                         else
                             con_root[i].ImageIndex := st_good;
                    end;
                 end
                 else begin
                      con_root[i].RecordItems.Add('Not applicable');
                      con_root[i].ImageIndex := st_good;
                 end;
                 WorkbenchQuery.Next;
             end;
        end;
        CloseWorkbenchConnection;
     end;
     {Finally close database.}
     {End tree update.}
     ConTree.EndUpdate;
end;

{Post start of shift data to database.}
procedure TBenchcheckForm.PostStartOfShiftData;
begin
     {Create tools register database object.}
     if CreateWorkbenchDatabaseConnection(self) then begin
        {Close user query connection and set SQL.}
        WorkbenchQuery.Close;
        WorkbenchQuery.SQL.Clear;
        WorkbenchQuery.SQL.Text := QPostStartOfShiftData;
        WorkbenchQuery.Prepare;
        {Set query parameters.}
        WorkbenchQuery.ParamByName('user').AsString      := Workbench.Username;
        WorkbenchQuery.ParamByName('loc').AsString       := Workbench.BenchName;
        WorkbenchQuery.ParamByName('sdate').AsDate       := Today;
        WorkbenchQuery.ParamByName('ctools').AsBoolean   := Workbench.ToolsConfirmed;
        WorkbenchQuery.ParamByName('ccons').AsBoolean    := Workbench.ConsumablesConfirmed;
        WorkbenchQuery.ParamByName('cstraps').AsBoolean  := Workbench.ESDStrapsConfirmed;
        WorkbenchQuery.ParamByName('cbench').AsBoolean   := Workbench.ESDBenchConfirmed;
        WorkbenchQuery.ParamByName('cjack').AsBoolean    := Workbench.ESDJacketConfirmed;
        WorkbenchQuery.ParamByName('csfod').AsBoolean    := Workbench.StartFODConfirmed;
        WorkbenchQuery.ParamByName('cext').AsBoolean     := Workbench.ExtractionConfirmed;
        {Execute query.}
        WorkbenchQuery.ExecSQL;
        {CLose database.}
        CloseWorkbenchConnection
     end;
end;

{Post end of shift data to database.}
procedure TBenchcheckForm.PostEndOfShiftData;
begin
     {Create tools register database object.}
     if CreateWorkbenchDatabaseConnection(self) then begin
        {Close user query connection and set SQL.}
        WorkbenchQuery.Close;
        WorkbenchQuery.SQL.Clear;
        WorkbenchQuery.SQL.Text := QUpdateEndOfShiftData;
        WorkbenchQuery.Prepare;
        {Set query parameters.}
        WorkbenchQuery.ParamByName('loc').AsString    := Workbench.BenchName;
        WorkbenchQuery.ParamByName('uname').AsString  := Workbench.Username;
        WorkbenchQuery.ParamByName('sdate').AsDate    := Today;
        WorkbenchQuery.ParamByName('equip').AsBoolean := Workbench.EOSEquipmentOff;
        WorkbenchQuery.ParamByName('efod').AsBoolean  := Workbench.EOSFODConfirmed;
        WorkbenchQuery.ParamByName('ewip').AsBoolean  := Workbench.EOSWIP;
        WorkbenchQuery.ParamByName('tcard').AsBoolean := Workbench.EOSTimecard;
        WorkbenchQuery.ParamByName('eos').AsBoolean   := true;
        {Execute query.}
        WorkbenchQuery.ExecSQL;
        {CLose database.}
        CloseWorkbenchConnection
     end;
end;

{Post new tool record to database.}
procedure TBenchcheckForm.PostToolRecord;
begin
     {Create tools register database object.}
     if CreateToolsDatabaseConnection(self) then begin
        {Set SQL search parameters and run query.}
        ToolsQuery.Close;
        ToolsQuery.SQL.Text := QPostNewToolRecord;
        ToolsQuery.Prepare;
        ToolsQuery.ParamByName('loc').AsString        := Workbench.BenchName;
        ToolsQuery.ParamByName('toolid').AsString     := ToolRecord.ToolID;
        ToolsQuery.ParamByName('type').AsString       := ToolRecord.ToolType;
        ToolsQuery.ParamByName('des').AsString        := ToolRecord.ToolDescription;
        ToolsQuery.ParamByName('set').AsString        := ToolRecord.ToolSetting;
        ToolsQuery.ParamByName('cal').AsBoolean       := ToolRecord.ToolCalRequired;
        if ToolRecord.ToolCalDate = NULLDATE then
           ToolsQuery.ParamByName('caldate').AsDateTime := NULLDATE
        else
            ToolsQuery.ParamByName('caldate').AsDateTime := ToolRecord.ToolCalDate;

        if ToolRecord.ToolExpDate = NULLDATE then
           ToolsQuery.ParamByName('due').AsDateTime := NULLDATE
        else
            ToolsQuery.ParamByName('due').AsDateTime := ToolRecord.ToolExpDate;
        {Excute query.}
        ToolsQuery.ExecSQL;
     end;
     CloseToolsConnection;
     {Refresh tool list.}
     GetToolsInformation;
end;

{Update tool record to database.}
procedure TBenchcheckForm.UpdateToolRecord;
begin
     {Create tools register database object.}
     if CreateToolsDatabaseConnection(self) then begin
        {Set SQL search parameters and run query.}
        ToolsQuery.Close;
        ToolsQuery.SQL.Text := QUpdateToolRecord;
        ToolsQuery.Prepare;
        ToolsQuery.ParamByName('loc').AsString        := Workbench.BenchName;
        ToolsQuery.ParamByName('toolid').AsString     := ToolRecord.ToolID;
        ToolsQuery.ParamByName('type').AsString       := ToolRecord.ToolType;
        ToolsQuery.ParamByName('des').AsString        := ToolRecord.ToolDescription;
        ToolsQuery.ParamByName('set').AsString        := ToolRecord.ToolSetting;
        ToolsQuery.ParamByName('cal').AsBoolean       := ToolRecord.ToolCalRequired;
        if ToolRecord.ToolCalDate = NULLDATE then
           ToolsQuery.ParamByName('caldate').AsDateTime := NULLDATE
        else
            ToolsQuery.ParamByName('caldate').AsDateTime := ToolRecord.ToolCalDate;

        if ToolRecord.ToolExpDate = NULLDATE then
           ToolsQuery.ParamByName('due').AsDateTime := NULLDATE
        else
            ToolsQuery.ParamByName('due').AsDateTime := ToolRecord.ToolExpDate;

        {Excute query.}
        ToolsQuery.ExecSQL;
     end;
     CloseToolsConnection;
     {Refresh tool list.}
     GetToolsInformation;
end;

procedure TBenchcheckForm.ToggleLED(LED: TcyAdvLED);
begin
     if LED.LedValue then
        LED.LedValue := false
     else
         LED.LedValue := true;
end;

{Delete tool item from database.}
procedure TBenchcheckForm.DeleteToolItem;
var
   item         : TTreeListItem;
   iText        : string;
begin
     {Get selected tree list item and read header}
     item  := ToolsTree.Selected;
     iText := item.Text;
     {Create tools register database object.}
     if CreateToolsDatabaseConnection(self) then begin
        {Set SQL search parameters and run query.}
        ToolsQuery.Close;
        ToolsQuery.SQL.Text := QDeleteToolItem;
        ToolsQuery.Prepare;
        ToolsQuery.ParamByName('loc').AsString := Workbench.BenchName;
        ToolsQuery.ParamByName('tool').AsString := iText;
        ToolsQuery.ExecSQL;
        {Close tools database.}
        CloseToolsConnection;
        {Refresh tools information.}
        GetToolsInformation;
     end;
end;

{Delete consumable from database.}
procedure TBenchcheckForm.DeleteConsItem;
var
   item         : TTreeListItem;
   iText        : string;
   ibatch       : integer;
begin
     {Get selected tree list item and read header}
     item  := ConTree.Selected;
     iText := item.Text;
     iBatch := StrToInt(item.RecordItemsText[2]);
     {Create tools register database object.}
     if CreateWorkbenchDatabaseConnection(self) then begin
        {Set SQL search parameters and run query.}
        WorkbenchQuery.Close;
        WorkbenchQuery.SQL.Text := QDeleteConsumableItem;
        WorkbenchQuery.Prepare;
        WorkbenchQuery.ParamByName('loc').AsString := Workbench.BenchName;
        WorkbenchQuery.ParamByName('part').AsString := iText;
        WorkbenchQuery.ParamByName('bat').AsInteger := iBatch;
        ConErrorLabel.Caption:= inttostr(ibatch);
        WorkbenchQuery.ExecSQL;
        {Close tools database.}
        CloseWorkbenchConnection;
        {Refresh tools information.}
        GetConInformation;
     end;
end;

{Initiate tool record page.}
procedure TBenchcheckForm.StartNewToolRecord;
begin
     {Create tool record object.}
     ToolRecord := TToolRecord.Create(self);
     ToolRecord.Newtool := true;
     {Clear edit fields if new record.}
     if ToolRecord.Newtool then begin
        ToolRefEdit.Text := '';
        ToolRefEdit.Enabled := true;
        ToolTypeCombo.Text := '';
        ToolTypeCombo.Enabled := false;
        ToolDesCombo.Text := '';
        ToolDesCombo.Enabled := false;
        ToolSetCombo.Text := '';
        ToolSetCombo.Enabled := false;
        CalReqCheckbox.Enabled := false;
        ToolStartDateCombo.Enabled := false;
        ToolStartDateCombo.MinDate:= Today;
        ToolExpDateCombo.Enabled := false;
        ToolExpDateCombo.MinDate := Today;
        {Show edit fields.}
        ToolRefEdit.Show;
        ToolTypeCombo.Show;
        ToolDesCombo.Show;
        ToolSetCombo.Show;
        ToolStartDateCombo.Show;
        ToolExpDateCombo.Show;
        ToolRefEdit.SetFocus;
     end;
end;

{Display and configure update tool record page.}
procedure TBenchcheckForm.StartUpdateToolRecord; 
var
   item         : TTreeListItem;
   iText        : string;
begin
     {Create tool record object.}
     ToolRecord := TToolRecord.Create(self);
     {Get selected tree list item and read text.}
     item  := ToolsTree.Selected;
     iText := item.Text;
     {Create tools register database object.}
     if CreateToolsDatabaseConnection(self) then begin
        {Set SQL search parameters and run query.}
        ToolsQuery.Close;
        ToolsQuery.SQL.Text := QSearchForToolItem;
        ToolsQuery.ParamByName('loc').AsString := Workbench.BenchName;
        ToolsQuery.ParamByName('tool').AsString := iText;
        ToolsQuery.Open;
        {Load tool record from database.}
        ToolRecord.ToolID           := iText;
        ToolRecord.ToolType         := ToolsQuery.FieldByName('type').AsString;
        ToolRecord.ToolDescription  := ToolsQuery.FieldByName('description').AsString;
        ToolRecord.ToolSetting      := ToolsQuery.FieldByName('setting').AsString;
        ToolRecord.ToolCalRequired  := ToolsQuery.FieldByName('calibrated').AsBoolean;
        ToolRecord.ToolCalDate      := ToolsQuery.FieldByName('caldate').AsDateTime;
        ToolRecord.ToolExpDate      := ToolsQuery.FieldByName('duedate').AsDateTime;
     end;
     {Close database connection.}
     CloseToolsConnection;
     {Populate and disable tool id edit field.}
     ToolRefEdit.Text               := ToolRecord.ToolID;
     ToolRefEdit.Enabled            := false;
     {Populate tool type combobox.}
     ToolTypeCombo.Text             := ToolRecord.ToolType;
     ToolRecord.GetToolTypeList(ToolTypeCombo.Items);
     ToolTypeCombo.Enabled          := true;
     {Populate tool description combobox.}
     ToolDesCombo.Text              := ToolRecord.ToolDescription;
     ToolRecord.GetToolDescriptionList(ToolDesCombo.Items);
     ToolDesCombo.Enabled           := true;
     {Populate tool settings combobox.}
     ToolSetCombo.Text              := ToolRecord.ToolSetting;
     ToolRecord.GetToolSetting(ToolSetCombo.Items);
     ToolSetCombo.Enabled           := true;
     {Set calibration required checkbox.}
     CalReqCheckbox.LedValue        := ToolRecord.ToolCalRequired;
     CalReqCheckbox.Enabled         := true;
     {Populate calibration date combobox.}
     if ToolRecord.ToolCalRequired then begin 
        ToolStartDateCombo.Enabled  := true;
        if ToolRecord.ToolCalDate <> 0 then
           ToolStartDateCombo.Date     := ToolRecord.ToolCalDate
        else
            SendMessageW (ToolStartDateCombo.Handle, WM_KEYDOWN, VK_N, 0);
     end else begin
         SendMessageW (ToolStartDateCombo.Handle, WM_KEYDOWN, VK_N, 0); 
         ToolStartDateCombo.Enabled  := false;
     end;
     {Populate calibration due date combobox.}
     if ToolRecord.ToolCalRequired then begin
        ToolExpDateCombo.Enabled  := true;
        if ToolRecord.ToolExpDate <> 0 then
           ToolExpDateCombo.Date     := ToolRecord.ToolExpDate
        else
            SendMessageW (ToolExpDateCombo.Handle, WM_KEYDOWN, VK_N, 0);
     end else begin
         SendMessageW (ToolExpDateCombo.Handle, WM_KEYDOWN, VK_N, 0);
         ToolExpDateCombo.Enabled  := false;
     end;
     {Show edit fields.}
     ToolRefEdit.Show;
     ToolTypeCombo.Show;
     ToolDesCombo.Show;
     ToolSetCombo.Show;
     ToolStartDateCombo.Show;
     ToolExpDateCombo.Show;
     ToolTypeCombo.SetFocus;
end;

{Extract bench extraction from tools database.}
function TBenchcheckForm.GetExtractionID: string;
begin
     result := '';
     {Create tools register database object.}
     if CreateToolsDatabaseConnection(self) then begin
        {Set SQL search parameters and run query.}
        ToolsQuery.Close;
        ToolsQuery.SQL.Text := QSearchForWorkbenchExtraction;
        ToolsQuery.ParamByName('loc').AsString := Workbench.BenchName;
        ToolsQuery.ParamByName('ext').AsString := 'Extraction';
        ToolsQuery.Open;
        {Check record count and display items.}
        if ToolsQuery.RecordCount <> 0 then begin
           result := ToolsQuery.FieldByName('ToolID').AsString;
        end;
     end;
     CloseToolsConnection;
end;

end.

