unit bcfilecopythread;

{$mode delphi}{$H+}

interface
uses
  Classes, SysUtils, Windows, Interfaces;

type

    { TFileCopy }

    TShowPositionEvent = procedure(value: integer) of object;

    TFileCopy = class(TThread)
      private
         fHandle           : DWord;
         fSource           : string;
         fDest             : string;
         fOnShowPosition   : TShowPositionEvent;
         fTerminated       : boolean;
      protected

      public
         constructor Create(aSource: string; aDest: string; afiles: array of string);
         Destructor Destroy;

         property handle      : DWord        read fHandle;
         property terminated  : boolean      read fTerminated;
    end;

var
   FCopy : TFileCopy;


implementation

{ TFileCopy }


constructor TFileCopy.Create(aSource: string; aDest: string; afiles: array of string);
begin
     FreeOnTerminate := true;
     fSource := aSource;
     fDest   := aDest;
     fHandle := ThreadId;
     inherited Create(true);
end;

destructor TFileCopy.Destroy;
begin

     inherited;
end;

end.

