unit bcsplash;

//{$mode objfpc}{$H+}
{$MODE DELPHI}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TSplashForm }

  TSplashForm = class(TForm)
    Bevel1: TBevel;
    Image2: TImage;
    Label1: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  SplashForm: TSplashForm;

implementation

uses
    AppRoutines, bcoptions;

{$R *.lfm}

{ TSplashForm }

procedure TSplashForm.Timer1Timer(Sender: TObject);
begin
     SplashForm.Close;
     SplashForm.Free;
end;

procedure TSplashForm.FormShow(Sender: TObject);
begin
     {Show version and aurthor}
     if Settings.RunningAdmin then
        label1.Caption:= 'Version ' + GetAppVersionStr(Application.ExeName)
                      + ' - Administration mode'
     else
         label1.Caption:= 'Version ' + GetAppVersionStr(Application.ExeName)
                      + ' by David Scambell';
     Timer1.Enabled:= true;
end;

procedure TSplashForm.FormCreate(Sender: TObject);
begin
     {Scale form}
end;

end.

