unit bcmain;

//{$mode objfpc}{$H+}
{$MODE DELPHI}{$H+}

interface

uses
  Classes, SysUtils, Windows, FileUtil, ECEditBtns, TreeListView,
  lrOfficeImport, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  win32int, InterfaceBase, Menus, ComCtrls, Buttons, DBGrids, Types, odbcconn,
  sqldb, mssqlconn, db, ipservices, stringvar;

type

  { TMainForm }

  TMainForm = class(TForm)
    ApplicationProperties: TApplicationProperties;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    AutoConfigButton: TECSpeedBtn;
    Bevel4: TBevel;
    Bevel5: TBevel;
    ComboBox: TComboBox;
    CreateFolderButton: TECSpeedBtn;
    BrowserButton: TECSpeedBtn;
    DefaultSettingsButton: TECSpeedBtn;
    IL32: TImageList;
    MenuItem2: TMenuItem;
    MenuManager: TMenuItem;
    MenuTools: TMenuItem;
    PrevButton: TECSpeedBtn;
    SettingsTreeList: TTreeListView;
    ThanksImage: TImage;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    ThanksLabel: TLabel;
    SurnameEdit: TEdit;
    FirstNameEdit: TEdit;
    NumberEdit: TEdit;
    Label12: TLabel;
    ScanEdit: TEdit;
    Label11: TLabel;
    Label3: TLabel;
    ListEditButton: TECSpeedBtn;
    MenuItem1: TMenuItem;
    MenuBenchcheck: TMenuItem;
    RestoreButton: TECSpeedBtn;
    RegSaveButton: TECSpeedBtn;
    IL24: TImageList;
    CoreCountLabel: TLabel;
    SysMemLabel: TLabel;
    SearchButton: TECSpeedBtn;
    editbox: TEdit;
    IL16: TImageList;
    LazarusLogo: TImage;
    Label1: TLabel;
    Label10: TLabel;
    HelpLabel: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    ResLabel: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    MenuGPL: TMenuItem;
    ProLabel: TLabel;
    StatusTree: TTreeView;
    SettingsPage: TTabSheet;
    ButtonRefresh: TTimer;
    BenchTimer: TTimer;
    ScanPage: TTabSheet;
    NewUserPage: TTabSheet;
    ThanksPage: TTabSheet;
    WinBuildLabel: TLabel;
    WinEdLabel: TLabel;
    WinVerLabel: TLabel;
    WIndowsLogo: TImage;
    PageControl: TPageControl;
    InfoPage: TTabSheet;
    WindowsIcons: TImageList;
    Label4: TLabel;
    MenuExit: TMenuItem;
    MenuLine1: TMenuItem;
    MenuLine2: TMenuItem;
    MenuConfig: TMenuItem;
    TrayMenu: TPopupMenu;
    TrayIcon: TTrayIcon;
    Image2: TImage;
    ExitButton: TECSpeedBtn;
    IL48: TImageList;
    Panel1: TPanel;
    procedure ApplicationPropertiesQueryEndSession(var Cancel: Boolean);
    procedure AutoConfigButtonClick(Sender: TObject);
    procedure AutoConfigButtonMouseEnter(Sender: TObject);
    procedure AutoConfigButtonMouseLeave(Sender: TObject);
    procedure BenchTimerTimer(Sender: TObject);
    procedure BrowserButtonClick(Sender: TObject);
    procedure BrowserButtonMouseEnter(Sender: TObject);
    procedure BrowserButtonMouseLeave(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBoxChange(Sender: TObject);
    procedure CreateFolderButtonClick(Sender: TObject);
    procedure CreateFolderButtonMouseEnter(Sender: TObject);
    procedure CreateFolderButtonMouseLeave(Sender: TObject);
    procedure ButtonRefreshTimer(Sender: TObject);
    procedure DefaultSettingsButtonClick(Sender: TObject);
    procedure DefaultSettingsButtonMouseEnter(Sender: TObject);
    procedure DefaultSettingsButtonMouseLeave(Sender: TObject);
    procedure FirstNameEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FirstNameEditKeyPress(Sender: TObject; var Key: char);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure Label14Click(Sender: TObject);
    procedure ListEditButtonClick(Sender: TObject);
    procedure ListEditButtonMouseEnter(Sender: TObject);
    procedure ListEditButtonMouseLeave(Sender: TObject);
    procedure MenuBenchcheckClick(Sender: TObject);
    procedure MenuManagerClick(Sender: TObject);
    procedure MenuToolsClick(Sender: TObject);
    procedure NumberEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure NumberEditKeyPress(Sender: TObject; var Key: char);
    procedure PrevButtonClick(Sender: TObject);
    procedure PrevButtonMouseEnter(Sender: TObject);
    procedure PrevButtonMouseLeave(Sender: TObject);
    procedure RegSaveButtonClick(Sender: TObject);
    procedure RegSaveButtonMouseEnter(Sender: TObject);
    procedure editboxKeyPress(Sender: TObject; var Key: char);
    procedure PageControlChange(Sender: TObject);
    procedure RegSaveButtonMouseLeave(Sender: TObject);
    procedure RestoreButtonClick(Sender: TObject);
    procedure RestoreButtonMouseEnter(Sender: TObject);
    procedure RestoreButtonMouseLeave(Sender: TObject);
    procedure ScanEditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
      );
    procedure ScanEditKeyPress(Sender: TObject; var Key: char);
    procedure ScanPageShow(Sender: TObject);
    procedure SearchButtonMouseEnter(Sender: TObject);
    procedure SearchButtonMouseLeave(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure SettingsTreeListClickAtItem(sender: TObject; item: TTreeListItem);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormShow(Sender: TObject);
    procedure FormWindowStateChange(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuConfigClick(Sender: TObject);
    procedure MenuGPLClick(Sender: TObject);
    procedure SettingsTreeListHeaderSectionResize(
      HeaderControl: TCustomHeaderControl; Section: THeaderSection);
    procedure SettingsTreeListVScrollBarChange(Sender: TObject);
    procedure SurnameEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SurnameEditKeyPress(Sender: TObject; var Key: char);
    procedure TrayIconDblClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure ExitButtonMouseEnter(Sender: TObject);
    procedure ExitButtonMouseLeave(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SetWindowsLogo;
  public
    { public declarations }

    procedure WndProc(var Msg: TMessage); override;
    procedure HideEditControls;
    procedure UpdateStatusTree;
    Procedure UpdateSettingsList;
    procedure ShowEditBox(atop: integer; aleft: integer; awidth: integer;
              aheight: integer; atext: string; aFBtn: boolean; aFldBtn: boolean;
              aBrwBtn: boolean; nums: boolean);
    procedure ShowComboBox(atop: integer; aleft: integer; awidth: integer;
              aheight: integer; aItems: array of string; index: integer;
              aedbtn: boolean);
    procedure CreateLink;
    procedure SetAutoStart(run: boolean);
    procedure AutoConfigHost;
    procedure SetBenchTimer;
    procedure ShowNewUserPage;
    procedure ShowScanpage;
    procedure ShowThanksPage;
    Procedure ShowInfoPage;
    procedure NextPage;
    procedure GetUserInformation;
    procedure RunBenchCheck;

    function PostUserInformation: boolean;

  end;



var
  MainForm                     : TMainForm;
  {Settings Tree List Edit components active flags.}
  EditBoxActive                : boolean = false;
  ComboBoxActive               : boolean = false;
  CreateFolderButtonActive     : boolean = false;
  SearchButtonActive           : boolean = false;
  BrowserButtonActive          : boolean = false;
  ListEditButtonActive         : boolean = false;
  ShowUserInfo                 : boolean = false;

  testtemp                     : string;


implementation

{$R *.lfm}

uses
    bcoptions, approutines, bcsplash, bcgplviewer, bcconstants, GreyScreen,
    bclisteditor, bcBenchcheck, bctoolreg, bcmanager, windowsutils;

{ TMainForm }

{Application startup procedure.}
procedure TMainForm.FormCreate(Sender: TObject);
begin
     {Set form title bar.}
     Caption := Application.Title + SettingsTitle;
     {Create application settings components}
     Settings := TSettings.Create(nil);
     WorkBench := TWorkBench.Create(nil);
     {Setup tray icon}
     TrayIcon.PopUpMenu := TrayMenu;
     {Show splash form}
     if (Settings.ShowSplashIndex = 0) and (not Settings.RunningAdmin) then
     begin
          SplashForm := TSplashForm.Create(nil);
          SplashForm.Show;
     end;
     {Update trees}
     UpdateSettingsList;
     {Load settings from host registry or source config file.}
     if Settings.HostConfigured then begin
        Settings.ReadRegistrySettings;
        WorkBench.ReadRegistrySettings;
     end
     else
         Settings.ReadFileSettings;
     {Update trees}
     UpdateSettingsList;
     {Set editing component parents}
     SettingsTreeList.Parent := SettingsPage;
     SettingsTreeList.Left:= 12;
     SettingsTreeList.Top := 12;
     editbox.Parent := SettingsTreeList;
     CreateFolderButton.Parent := SettingsTreeList;
     BrowserButton.Parent := SettingsTreeList;
     SearchButton.Parent  := SettingsTreeList;
     ListEditButton.Parent := SettingsTreeList;
     Combobox.Parent := SettingsTreeList;
     {Create desktop links.}
     CreateLink;
     {Initiate benchcheck timer.}
     if Workbench.BenchcheckIndex = 0 then begin
        if not Settings.RunningAdmin then
           SetBenchTimer;
     end;
     {Send initiate get user info message.}
     GetUserInformation;
     {Run tool register if start on application startup set.}
     if (not Settings.RunningAdmin) and (Workbench.RunToolAtStart = 0) then
        Windows.SendMessageTimeout(HWND_BROADCAST, ToolsMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);
end;

procedure TMainForm.WndProc(var Msg: TMessage);
begin
     {Show mainform.}
     if Msg.msg = CoreMessage then
     begin
          MainForm.Show;
          MainForm.ShowInTaskBar:= stDefault;
     end else
     {Show benchcheck form.}
     if Msg.msg = BenchMessage then
          RunBenchCheck
     else
     {Show tool register form.}
     if Msg.msg = ToolsMessage then
     begin
          if not assigned(ToolForm) then
             ToolForm := TToolForm.Create(Application);
          ToolForm.Show;
     end else
     {Show manager form.}
     if Msg.msg = ManagerMessage then
     begin
          if not assigned(ManagerForm) then
             ManagerForm := TManagerForm.Create(Application);
          ManagerForm.Show;
     end else
         inherited WndProc(Msg);
end;


procedure TMainForm.ExitButtonMouseEnter(Sender: TObject);
begin
     if ExitButton.ImageIndex = 0 then ExitButton.ImageIndex := 1;
     if ExitButton.ImageIndex = 14 then ExitButton.ImageIndex := 15;
end;

procedure TMainForm.ExitButtonClick(Sender: TObject);
begin
     if Pagecontrol.ActivePage = NewUserPage then begin
        NextPage;
        ScanEdit.Text := Workbench.Password;
     end else
     if Pagecontrol.ActivePage = ScanPage then begin
        NextPage;
     end else
     if Pagecontrol.ActivePage = ThanksPage then begin
        NextPage;
     end else
         Hide;
end;

procedure TMainForm.ExitButtonMouseLeave(Sender: TObject);
begin
     if ExitButton.ImageIndex = 1 then ExitButton.ImageIndex := 0;
     if ExitButton.ImageIndex = 15 then ExitButton.ImageIndex := 14;
end;

procedure TMainForm.ApplicationPropertiesQueryEndSession(var Cancel: Boolean);
begin
     {Block system shutdown, post reason on Windows Vista+}
     if Settings.BlockShutdown then begin
        cancel := true;
        ShutdownBlockReasonCreate(WidgetSet.AppHandle, 'Please complete todays daily bench check list before you shutdown.');
     end;
     //ShutdownBlockReasonDestroy(AppOptions.AppHandle);
end;

procedure TMainForm.AutoConfigButtonClick(Sender: TObject);
begin
     //AutoConfigHost;
end;

procedure TMainForm.AutoConfigButtonMouseEnter(Sender: TObject);
begin
     if AutoConfigButton.ImageIndex = 2 then AutoConfigButton.ImageIndex := 3;
     If AutoCOnfigButton.ImageIndex = 4 then AutoConfigButton.ImageIndex := 5;
end;

procedure TMainForm.AutoConfigButtonMouseLeave(Sender: TObject);
begin
     if AutoConfigButton.ImageIndex = 3 then AutoConfigButton.ImageIndex := 2;
     If AutoCOnfigButton.ImageIndex = 5 then AutoConfigButton.ImageIndex := 4;
end;

procedure TMainForm.BenchTimerTimer(Sender: TObject);
begin
     {Send benchchech launch message.}
     Windows.SendMessageTimeout(HWND_BROADCAST, BenchMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);
end;

procedure TMainForm.BrowserButtonMouseEnter(Sender: TObject);
begin
     BrowserButton.ImageIndex := 11;
end;

procedure TMainForm.BrowserButtonMouseLeave(Sender: TObject);
begin
     BrowserButton.ImageIndex := 10;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
     GetNetworkInterfaces(NetworkInterfaceList);
     label11.caption := NetworkInterfaceList[0].AddrIP;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
end;

procedure TMainForm.CreateFolderButtonMouseEnter(Sender: TObject);
begin
     CreateFolderButton.ImageIndex := 6;
end;

procedure TMainForm.CreateFolderButtonMouseLeave(Sender: TObject);
begin
     CreateFolderButton.ImageIndex := 5;
end;

procedure TMainForm.FormHide(Sender: TObject);
begin
     {Close GPL form if open.}
     if assigned(GPLForm) then GPLForm.Close;
     {Close list editor form.}
     if assigned(ListEditor) then ListEditor.Close;
     {Clear form stay on top.}
     StayOnTop(MainForm, false);
     {Close grey form if open.}
     ClearDesktop;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
     CanClose := false;
     Hide;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
     {Disable bench check timer.}
     BenchTimer.Enabled := false;
     {Display version information.}
     if Settings.RunningAdmin then
        Label4.Caption:= 'Version ' + GetAppVersionStr(WorkbenchEXE) + ' - Administration mode'
     else
        Label4.Caption:= 'Version ' + GetAppVersionStr(WorkbenchEXE);
     {Display Windows version.}
     WinVerLabel.Caption:= Settings.WindowsName;
     if Settings.WindowsEdition = '' then
     begin
          if Settings.WindowsCSDVersion = '' then
             WinEdLabel.Caption:= 'Build ' + inttostr(settings.WindowsBulid)
          else
             WinEdLabel.Caption:= settings.WindowsCSDVersion + ' Build ' +
                                  inttostr(settings.WindowsBulid);
          WinBuildLabel.Caption := '';
     end
     else
     begin
          WinEdLabel.Caption:= Settings.WindowsEdition;
          if Settings.WindowsCSDVersion = '' then
             WinBuildLabel.Caption:= 'Build ' + inttostr(settings.WindowsBulid)
          else
             WinBuildLabel.Caption:= settings.WindowsCSDVersion + ' Build ' +
                                  inttostr(settings.WindowsBulid);
     end;
     SetWindowsLogo;
     {Display Processor type and core count.}
     ProLabel.Caption := Settings.ProcessorName + '.';
     CoreCountLabel.Caption :=  IntToStr(GetLogicalCPUCount) + ' logical processor cores available.';
     {DIsplay physical system memory.}
     SysMemLabel.Caption := GetSystemMem + ' of physical memory installed.';
     {Display screen resolution.}
     ResLabel.Caption:= IntToStr(Settings.ScreenWidth) + ' x ' +
                        IntToStr(Settings.ScreenHeight) + ' pixel screen resolution.';
     {Hide settings list edit components.}
     HideEditControls;
     {Hide settings tab if not running as administrator and administrator user account.}
     if (not Settings.IsAdminAcount) or (not Settings.RunningAdmin) then
        Pagecontrol.ShowTabs := false;
     {Make info page active page on form show.}
     PageControl.ActivePage := InfoPage;
     {Show user infomation form.}
     If ShowUserInfo then  ShowNewUserPage;
     {Update settings.}
     UpdateSettingsList;
end;

procedure TMainForm.SetWindowsLogo;
begin
     {Display Windows XP Icon}
     if Settings.WindowsVerMajor = 5 then
        WindowsIcons.GetIcon(0, WindowsLogo.Picture.Icon);
     {Display Windows Vista Icon}
     if (Settings.WindowsVerMajor = 6) and (Settings.WindowsVerMinor = 0) then
        WindowsIcons.GetIcon(1, WindowsLogo.Picture.Icon);
     {Display Windows 7 Icon}
     if (Settings.WindowsVerMajor = 6) and (Settings.WindowsVerMinor = 1) then
        WindowsIcons.GetIcon(2, WindowsLogo.Picture.Icon);
     {Display Windows 8 Icon}
     if (Settings.WindowsVerMajor = 6) and (Settings.WindowsVerMinor = 2) then
        WindowsIcons.GetIcon(3, WindowsLogo.Picture.Icon);
     {Display Windows 8.1 Icon}
     if (Settings.WindowsVerMajor = 6) and (Settings.WindowsVerMinor = 3) then
        WindowsIcons.GetIcon(4, WindowsLogo.Picture.Icon);
     {Display Windows 10 Icon}
     if Settings.WindowsVerMajor = 10 then
        WindowsIcons.GetIcon(5, WindowsLogo.Picture.Icon);
end;

procedure TMainForm.FormWindowStateChange(Sender: TObject);
begin
     if MainForm.WindowState = wsMinimized then
     begin
        MainForm.Hide;
        MainForm.ShowInTaskBar := stNever;
        MainForm.WindowState:= wsNormal;
     end;
end;

procedure TMainForm.MenuExitClick(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TMainForm.MenuConfigClick(Sender: TObject);
begin
     {Send benchchech launch message.}
     Windows.SendMessageTimeout(HWND_BROADCAST, CoreMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);
end;

procedure TMainForm.MenuGPLClick(Sender: TObject);
begin
     if not assigned(GPLForm) then
        GPLForm := TGPLForm.Create(nil);
     GPLForm.Show;
end;

procedure TMainForm.SettingsTreeListHeaderSectionResize(
  HeaderControl: TCustomHeaderControl; Section: THeaderSection);
var
   bounds      : TRect;
begin
     {Start update if list item selected.}
     if SettingsTreeList.Selected <> nil then begin;
        {Get selected items position.}
        bounds := SettingsTreeList.Selected.getBounds(1);
        {Update EditBox.}
        if EditBoxActive then
           if ListEditButtonActive then
              EditBox.Width := bounds.Right - bounds.Left - 28;
     end;
end;

procedure TMainForm.TrayIconDblClick(Sender: TObject);
begin
     {Send benchchech launch message.}
     Windows.SendMessageTimeout(HWND_BROADCAST, BenchMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);
end;

{Refresh edit button}
procedure TMainForm.ButtonRefreshTimer(Sender: TObject);
begin
     ButtonRefresh.Enabled := false;
     CreateFolderButton.Repaint;
     BrowserButton.Repaint;
     SearchButton.Repaint;
     ListEditButton.Repaint;
     ButtonRefresh.Enabled := true;
end;

procedure TMainForm.DefaultSettingsButtonClick(Sender: TObject);
begin
     {Update host registry.}
     Settings.SaveFileSettings;
     {Hide regitry update button.}
     Settings.FileChange := false;
     DefaultSettingsButton.Hide;
     {Update settings list.}
     UpdateSettingsList;
end;

procedure TMainForm.DefaultSettingsButtonMouseEnter(Sender: TObject);
begin
     DefaultSettingsButton.ImageIndex := 9;
end;

procedure TMainForm.DefaultSettingsButtonMouseLeave(Sender: TObject);
begin
     DefaultSettingsButton.ImageIndex := 8;
end;

procedure TMainForm.FirstNameEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key = vk_tab then begin
        Key := 0;
        Workbench.Firstname := UpperCaseFirstChar(FirstNameEdit.Text);
        FirstNameEdit.Text := Workbench.Firstname;
        SurnameEdit.SetFocus;
     end;
end;

procedure TMainForm.FirstNameEditKeyPress(Sender: TObject; var Key: char);
begin
     {Only except alphabetical characters.}
     if not (Key in ['a'..'z', 'A'..'Z', #13, #08, #127]) then key := #0;
     {Save data on enter key press.}
     if key = #13 then begin
        Key := #0;
        Workbench.Firstname := UpperCaseFirstChar(FirstNameEdit.Text);
        FirstNameEdit.Text := Workbench.Firstname;
        SurnameEdit.SetFocus;
     end;
end;

procedure TMainForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
     {Close and destroy user database connection.}
     CloseUserConnection;
end;

procedure TMainForm.Label14Click(Sender: TObject);
begin

end;

procedure TMainForm.SurnameEditKeyPress(Sender: TObject; var Key: char);
begin
     {Only except alphabetical characters.}
     if not (Key in ['a'..'z', 'A'..'Z', #13, #08, #127]) then key := #0;
     {Save data on enter key press.}
     if key = #13 then begin
        Key := #0;
        Workbench.Surname := UpperCaseFirstChar(SurnameEdit.Text);
        SurnameEdit.Text := Workbench.Surname;
        NumberEdit.SetFocus;
     end;
end;

procedure TMainForm.SurnameEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key = vk_tab then begin
        Key := 0;
        Workbench.Surname := UpperCaseFirstChar(SurnameEdit.Text);
        SurnameEdit.Text := Workbench.Surname;
        NumberEdit.SetFocus;
     end;
end;

procedure TMainForm.NumberEditKeyPress(Sender: TObject; var Key: char);
begin
     {Only except numerical characters.}
     if not (Key in ['0'..'9', #13, #08, #127]) then key := #0;
     {Save data on enter key press.}
     if key = #13 then begin
        Key := #0;
        if NumberEdit.Text <> '' then begin
           Workbench.EmployeeNumber := StrToInt(NumberEdit.Text);
           NextPage;
        end;
     end;
end;

procedure TMainForm.PrevButtonClick(Sender: TObject);
begin
     If Pagecontrol.ActivePage = ThanksPage then begin
        Pagecontrol.ActivePage := ScanPage;
        ScanEdit.Text := Workbench.Password;
        ScanEdit.SetFocus;
        if Workbench.Password <> '' then ExitButton.Enabled := true;
     end
     else
     If Pagecontrol.ActivePage = ScanPage then begin
        Pagecontrol.ActivePage := NewUserPage;
        FirstNameEdit.SetFocus;
        PrevButton.Enabled := false;
        if (Workbench.Firstname <> '') and (Workbench.Surname <> '') and
              (Workbench.EmployeeNumber <> 0) then ExitButton.Enabled := true;
     end;
end;

procedure TMainForm.PrevButtonMouseEnter(Sender: TObject);
begin
     PrevButton.ImageIndex := 17;
end;

procedure TMainForm.PrevButtonMouseLeave(Sender: TObject);
begin
     PrevButton.ImageIndex := 16;
end;

procedure TMainForm.NumberEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key = vk_tab then begin
        Key := 0;
        if NumberEdit.Text <> '' then begin
           Workbench.EmployeeNumber := StrToInt(NumberEdit.Text);
           NextPage;
        end;
     end;
end;

procedure TMainForm.ListEditButtonClick(Sender: TObject);
begin
     if not assigned(ListEditor) then
        ListEditor := TListEditor.Create(nil);
     ListEditor.Show;
     HideEditControls;
end;

procedure TMainForm.ListEditButtonMouseEnter(Sender: TObject);
begin
     ListEditButton.ImageIndex := 20;
end;

procedure TMainForm.ListEditButtonMouseLeave(Sender: TObject);
begin
     ListEditButton.ImageIndex := 19;
end;

procedure TMainForm.MenuBenchcheckClick(Sender: TObject);
begin
     {Send benchchech launch message.}
     Windows.SendMessageTimeout(HWND_BROADCAST, BenchMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);
end;

procedure TMainForm.MenuManagerClick(Sender: TObject);
begin
     {Send benchchech launch message.}
     Windows.SendMessageTimeout(HWND_BROADCAST, ManagerMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);
end;

procedure TMainForm.MenuToolsClick(Sender: TObject);
begin
     {Send benchchech launch message.}
     Windows.SendMessageTimeout(HWND_BROADCAST, ToolsMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);
end;

procedure TMainForm.RegSaveButtonClick(Sender: TObject);
begin
     {Update host registry.}
     Settings.SaveRegistrySettings;
     WorkBench.SaveRegistrySettings;
     {Hide regitry update button.}
     Settings.RegistryChange := false;
     RegSaveButton.Hide;
     {Update settings list.}
     UpdateSettingsList;
end;

procedure TMainForm.RegSaveButtonMouseEnter(Sender: TObject);
begin
     RegSaveButton.ImageIndex := 7;
end;

procedure TMainForm.PageControlChange(Sender: TObject);
begin
     {Update settings page on selecting.}
     if PageControl.ActivePage = SettingsPage then begin
        if Settings.HostConfigured then begin
           AutoConfigButton.ImageIndex := 4;
           AutoConfigButton.Hint := 'Remove application from this system.';
           AutoConfigButton.Show;
        end
        else begin
           AutoConfigButton.ImageIndex := 2;
           AutoConfigButton.Hint := 'Configure application on this system.';
           AutoConfigButton.Show;
           RegSaveButton.Show;
           DefaultSettingsButton.Show;
        end;
        RestoreButton.Show;
     end
     else begin
        AutoConfigButton.Hide;
        RestoreButton.Hide;
        RegSaveButton.Hide;
        DefaultSettingsButton.Hide;
     end;

     {Update settings treelist.}

     UpdateSettingsList;
end;

procedure TMainForm.RegSaveButtonMouseLeave(Sender: TObject);
begin
     RegSaveButton.ImageIndex := 6;
end;

procedure TMainForm.RestoreButtonClick(Sender: TObject);
begin
     {Reset properties to default values.}
     Settings.SetDefaultValues;
     Workbench.SetDefaultValues;
     {Show save to registry and file buttons.}
     Settings.RegistryChange := true;
     Settings.FileChange := true;
     {Update settings tree list.}
     UpdateSettingsList;
end;

procedure TMainForm.RestoreButtonMouseEnter(Sender: TObject);
begin
     RestoreButton.ImageIndex := 11;
end;

procedure TMainForm.RestoreButtonMouseLeave(Sender: TObject);
begin
     RestoreButton.ImageIndex := 10;
end;

procedure TMainForm.ScanEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key = vk_tab then begin
        Key := 0;
        Workbench.Password := UpperCase(ScanEdit.Text);
        ScanEdit.Text := Workbench.Password;
        NextPage;
     end;
end;

procedure TMainForm.ScanEditKeyPress(Sender: TObject; var Key: char);
begin
     {Only except alphabetical or numerical characters.}
     if not (Key in ['a'..'z', 'A'..'Z', '0'..'9', #13, #08, #127]) then key := #0;
     {Save data on enter key press.}
     if key = #13 then begin
        Key := #0;
        Workbench.Password := UpperCase(ScanEdit.Text);
        ScanEdit.Text := Workbench.Password;
        NextPage;
     end;
end;

procedure TMainForm.ScanPageShow(Sender: TObject);
begin
     //ScanEdit.SetFocus;
end;

procedure TMainForm.SearchButtonMouseEnter(Sender: TObject);
begin
     SearchButton.ImageIndex := 13;
end;

procedure TMainForm.SearchButtonMouseLeave(Sender: TObject);
begin
     SearchButton.ImageIndex := 12;
end;

{Hide tree list edit controls}
procedure TMainForm.HideEditControls;
begin
     {Hide edit boxes and buttons}
     editbox.Hide;
     CreateFolderButton.Hide;
     BrowserButton.Hide;
     SearchButton.Hide;
     ListEditButton.Hide;
     ComboBox.Hide;
     HelpLabel.Caption:= '';
     EditBoxActive := false;
     ComboBoxActive := false;
     CreateFolderButtonActive := false;
     SearchButtonActive := false;
     BrowserButtonActive := false;
     ListEditButtonActive := false;
end;

{Show editbox and buttons when tree list clicked}
procedure TMainForm.ShowEditBox(atop: integer; aleft: integer; awidth: integer;
  aheight: integer; atext: string; aFBtn: boolean; aFldBtn: boolean;
  aBrwBtn: boolean; nums: boolean);
var
   count      : integer = 0;
   scroll     : integer = 0;
begin
     {Determine button count}
     if aFBtn then count               := 1;
     if aFldBtn then count             := 1;
     if aBrwBtn then count             := 1;
     if aFldBtn and aBrwBtn then count := 2;
     {Show folder button}
     if aFldBtn then begin
        with CreateFolderButton do
        begin
             Top          := atop + 1;
             if count = 1 then Left := aleft + awidth - 25 - scroll;
             if count = 2 then Left := aleft + awidth - 48 - scroll;
             Width        := 24;
             Height       := aheight - 2;
             show;
             ButtonRefresh.Enabled := true;
             CreateFolderButtonActive := true;
        end;
     end;
     {Show browser button}
     if aBrwBtn then begin
        with BrowserButton do
        begin
             Top          := atop + 1;
             Left         := aleft + awidth - 25 - scroll;
             Width        := 24;
             Height       := aheight - 2;
             Show;
             ButtonRefresh.Enabled := true;
             BrowserButtonActive := true;
        end;
     end;
     {Show file search button}
     if aFBtn then begin
        with SearchButton do
        begin
             Top          := atop + 1;
             Left         := aleft + awidth - 25 - scroll;
             Width        := 24;
             Height       := aheight - 2;
             Show;
             ButtonRefresh.Enabled := true;
             SearchButtonActive := true;
        end;
     end;
     {Show edit box, size to fit tree list item & display item text}
     with editbox do
     begin
          {Set editbox height and width to fit within selected row and buttons}
          Top          := atop + 1;
          Left         := aleft - 1;
          if count = 0 then Width := awidth - scroll -1;
          if count = 1 then Width := awidth - 25 - scroll;
          if count = 2 then Width := awidth - 50 - scroll;
          Height       := aheight - 2;
          Text         := aText;
          NumbersOnly  := nums;
          Show;
          SetFocus;
          EditBoxActive := true;
     end;
end;

{Show combo box when tree list clicked}
procedure TMainForm.ShowComboBox(atop: integer; aleft: integer;
  awidth: integer; aheight: integer; aItems: array of string; index: integer;
  aedbtn: boolean);
var
   i          : integer = 0;
   scroll     : integer = 0;
begin
     {Hide editing controls}
     HideEditControls;
     {Show folder button}
     if aedbtn then begin
        with ListEditButton do
        begin
             Top          := atop + 1;
             Left         := aleft + awidth - 25 - scroll;
             Width        := 24;
             Height       := aheight - 2;
             show;
             ButtonRefresh.Enabled := true;
             ListEditButtonActive := true;
        end;
     end;
     {Show combo box, size to fit tree list item & display item text}
     with combobox do
     begin
          {Set editbox height and width to fit within selected row and buttons}
          Top          := atop + 1;
          Left         := aleft - 1;
          if aedbtn then
             Width := awidth - scroll - 25
          else
              Width := awidth - scroll;
          Height       := aheight - 2;
          Items.Clear;
          for i := 0 to high(aItems) do begin
               Items.Add(aItems[i]);
          end;
          ItemIndex := index;
          Show;
          SelLength := 0;
          ComboBoxActive := true;
     end;
end;

{Create desktop icon.}
procedure TMainForm.CreateLink;
begin
     {Delete existing Benchcheck link.}
     if FileExists(Settings.HostRootDrive + Settings.DesktopDir + BenchCheckLink) then
                     DeleteFile(PChar(Settings.HostRootDrive + Settings.DesktopDir + BenchCheckLink));

     {Delete existing tool register link.}
     if FileExists(Settings.HostRootDrive + Settings.DesktopDir + ToolRegisterLink) then
                     DeleteFile(PChar(Settings.HostRootDrive + Settings.DesktopDir + ToolRegisterLink));

     {Delete existing tool register link.}
     if FileExists(Settings.HostRootDrive + Settings.DesktopDir + ManagerLink) then
                     DeleteFile(PChar(Settings.HostRootDrive + Settings.DesktopDir + ManagerLink));

     {Create link to application run from remote directory.}
     if Settings.StartFromIndex = 0 then begin
        {Check if file exists.}
        if FileExists(Settings.RemoteDrive + Settings.RemoteDirectory + WorkbenchEXE) then begin
           {Create benchcheck link from remote directory if benchcheck required.}
           if Workbench.BenchcheckIndex = 0 then begin
              if Workbench.BenchIconIndex = 0 then
                 CreateDesktopShortcut(Settings.RemoteDrive + Settings.RemoteDirectory + WorkbenchEXE,
                    '-b', 'Workbench Benchcheck', Settings.RemoteDrive + Settings.RemoteDirectory + WorkbenchIcon);
           end;

           {Create tool register link from remote directory.}
           if Workbench.ToolsIconIndex = 0 then
              CreateDesktopShortcut(Settings.RemoteDrive + Settings.RemoteDirectory +  WorkbenchEXE,
                  '-t', 'Workbench Tool Register', Settings.RemoteDrive + Settings.RemoteDirectory + WorkbenchToolsIcon);

           {Create manager link from remote directory.}
           if Workbench.ManagerIconIndex = 0 then
              CreateDesktopShortcut(Settings.RemoteDrive + Settings.RemoteDirectory +  WorkbenchEXE,
                  '-m', 'Workbench Manager', Settings.RemoteDrive + Settings.RemoteDirectory + WorkbenchManagerIcon);
        end;
     end;

     {Create link to application run from host directory.}
     if Settings.StartFromIndex = 1 then
        {Check if file exists.}
        if FileExists(IncludeTrailingPathDelimiter(Settings.HostRootDrive +
              Settings.HostAppDirectory) + WorkbenchEXE) then begin
              {Create benchcheck link from host directory if benchcheck is required.}
              if Workbench.BenchcheckIndex = 0 then begin;
                 if Workbench.BenchIconIndex = 0 then
                    CreateDesktopShortcut(IncludeTrailingPathDelimiter(Settings.HostRootDrive +
                      Settings.HostAppDirectory) + WorkbenchEXE, '-b', 'Workbench Benchcheck',
                      IncludeTrailingPathDelimiter(Settings.HostRootDrive +
                      Settings.HostAppDirectory) + WorkbenchIcon);
              end;

              {Create tool register link from host directory.}
              if Workbench.ToolsIconIndex = 0 then
                    CreateDesktopShortcut(IncludeTrailingPathDelimiter(Settings.HostRootDrive +
                      Settings.HostAppDirectory) + WorkbenchEXE, '-t', 'Workbench Tool Register',
                      IncludeTrailingPathDelimiter(Settings.HostRootDrive +
                      Settings.HostAppDirectory) + WorkbenchToolsIcon);

              {Create manager link from host directory.}
              if Workbench.ManagerIconIndex = 0 then
                    CreateDesktopShortcut(IncludeTrailingPathDelimiter(Settings.HostRootDrive +
                      Settings.HostAppDirectory) + WorkbenchEXE, '-m', 'Workbench Manager',
                      IncludeTrailingPathDelimiter(Settings.HostRootDrive +
                      Settings.HostAppDirectory) + WorkbenchManagerIcon);
     end;
     RefreshDesktop;
end;

{Set application auto start registry key.}
procedure TMainForm.SetAutoStart(run: boolean);
begin
     if run then begin
        if Settings.StartFromIndex = 0 then begin
           if FileExists(Settings.RemoteDrive + Settings.RemoteDirectory + WorkbenchEXE) then
                 WriteRegistryString(RegHKLM, RegAutoStart, WorkBenchSuite,
                           Settings.RemoteDrive + Settings.RemoteDirectory + WorkbenchEXE);
        end;
        if Settings.StartFromIndex = 1 then begin
           if FileExists(Settings.HostRootDrive + Settings.HostAppDirectory + WorkbenchEXE) then
              WriteRegistryString(RegHKLM, RegAutoStart, WorkBenchSuite,
                       Settings.HostRootDrive + Settings.HostAppDirectory + WorkbenchEXE);
        end;
     end;
     if not run then DeleteRegistryField(RegHKLM, RegAutoStart, WorkBenchSuite);
end;

{Update application status tree}
procedure TMainForm.UpdateStatusTree;
var
   {Root nodes}
   db_root     : TTreeNode;
   app_root    : TTreeNode;
   env_root    : TTreeNode;
   bch_root    : TTreeNode;
   i           : integer;
   app_errors  : array of TTreeNode;
   env_errors  : array of TTreeNode;
   bch_errors  : array of TTreeNode;
   db_errors   : array of TTreeNode;
begin
     {Begin treeview update and clear items}
     StatusTree.BeginUpdate;
     StatusTree.Items.Clear;
     with StatusTree.Items do
     begin
          {Create user status root node and set state icon.}
          db_root := Add(nil, 'Current user account.');
          SetNodeImage(db_root, at_info);
          {Display current user information.}
          if Settings.IsAdminAcount then
             AddChild(db_root, Workbench.Username + ' (Administrator.)')
          else
              AddChild(db_root, Workbench.Username);
          SetNodeImage(db_root.Items[0], at_user);

          {Create workbench status root node and set state icon.}
          bch_root := Add(nil, 'Workbench properties.');
          if Settings.WorkBenchStatus then
             SetNodeImage(bch_root, at_good)
          else
          begin
               SetNodeImage(bch_root, at_bad);
               {Create application status child nodes}
               SetLength(bch_errors, Settings.WorkbenchErrorList.Count);
               for i := 0 to Settings.WorkbenchErrorList.Count - 1 do
               begin
                    bch_errors[i] := AddChild(bch_root, Settings.WorkbenchErrorList[i]);
                    SetNodeImage(bch_errors[i], at_error);
               end;
          end;

          {Create environmental status root node and set state icon.}
          env_root := Add(nil, 'Environmental properties.');
          if Settings.EnvStatus then
             SetNodeImage(env_root, at_good)
          else
          begin
               SetNodeImage(env_root, at_bad);
               {Create application status child nodes}
               SetLength(env_errors, Settings.EnvErrorList.Count);
               for i := 0 to Settings.EnvErrorList.Count - 1 do
               begin
                    env_errors[i] := AddChild(env_root, Settings.EnvErrorList[i]);
                    SetNodeImage(env_errors[i], at_error);
               end;
          end;

          {Create application status root node and set state icon.}
          app_root := Add(nil, 'Application properties.');
          if Settings.AppStatus then
             SetNodeImage(app_root, at_good)
          else
          begin
               SetNodeImage(app_root, at_bad);
               {Create application status child nodes}
               SetLength(app_errors, Settings.AppErrorList.Count);
               for i := 0 to Settings.AppErrorList.Count - 1 do
               begin
                    app_errors[i] := AddChild(app_root, Settings.AppErrorList[i]);
                    SetNodeImage(app_errors[i], at_error);
               end;
          end;

          {Create database status root node and set state icon.}
          db_root := Add(nil, 'Database properties.');
          if Settings.DBStatus then
             SetNodeImage(db_root, at_good)
          else
          begin
               SetNodeImage(db_root, at_bad);
               {Create database status child nodes}
               SetLength(db_errors, Settings.DBErrorList.Count);
               for i := 0 to Settings.DBErrorList.Count - 1 do
               begin
                    db_errors[i] := AddChild(db_root, Settings.DBErrorList[i]);
                    SetNodeImage(db_errors[i], at_error);
               end;
          end;
     end;
     StatusTree.EndUpdate;
end;

{Update application settings treelist.}
procedure TMainForm.UpdateSettingsList;
var
   {Root nodes}
   env_root            : TTreeListItem;
   db_root             : TTreeListItem;
   bch_root            : TTreeListItem;
   app_root            : TTreeListItem;
   bchk_root           : TTreeListItem;
   user_root           : TTreeListItem;
   tool_root           , man_root: TTreeListItem;
   iNumber             : integer = 0;
begin
     {Begin tree update}
     SettingsTreeList.BeginUpdate;
     SettingsTreeList.Items.Clear;
     HelpLabel.Caption := '';
     {Clear error lists}
     Settings.AppErrorList.Clear;
     Settings.EnvErrorList.Clear;
     Settings.WorkbenchErrorList.Clear;
     Settings.DBErrorList.Clear;
     {Reset status error flags.}
     Settings.EnvStatus := true;
     Settings.WorkBenchStatus := true;
     Settings.AppStatus := true;
     Settings.DBStatus := true;

     Settings.ConfigFault := false;

     {Create bench settings root node.}
     bch_root := SettingsTreeList.Items.Add('Workbench properties.');
     with bch_root do
     begin
          iNumber := 0;
          ImageIndex := st_bch;

          {Display bench name property.}
          SubItems.Add('Workbench name.').RecordItems.Add(WorkBench.BenchName);
          if WorkBench.BenchName <> '' then begin
             SubItems[iNumber].ImageIndex := st_good;
          end
          else
          begin
               SubItems[iNumber].ImageIndex := st_error;
               Settings.WorkBenchStatus := false;
               Settings.WorkbenchErrorList.Add('Workbench name not set.');
               Settings.ConfigFault := true;
          end;

          {Display bench location combo.}
          SubItems.Add('Workbench location.').RecordItems.Add(Workbench.BenchLocation);
          inc(iNumber);
          if WorkBench.BenchLocation <> '' then begin
             SubItems[iNumber].ImageIndex := st_good;
          end
          else
          begin
               SubItems[iNumber].ImageIndex := st_error;
               Settings.WorkBenchStatus := false;
               Settings.WorkbenchErrorList.Add('Workbench location not set.');
               Settings.ConfigFault := true;
          end;
     end;

     {Create manager root node.}
     man_root := SettingsTreeList.Items.Add('Management properties.');
     with man_root do
     begin
          ImageIndex := st_man;

          {Display new user restrictin default property.}
          SubItems.Add('Restrict new user access?').RecordItems.Add(
                                 cbi_yesno[Settings.RestrictAccessDefault]);
          SubItems[0].ImageIndex := st_dropdown;

          {Display create manager link property.}
          SubItems.Add('Create manager link.').RecordItems.Add(
                               cbi_yesno[Workbench.ManagerIconIndex]);
          SubItems[1].ImageIndex := st_dropdown;
     end;

     {Create daily Benchcheck root node}
     bchk_root := SettingsTreeList.Items.Add('Daily benchcheck properties.');
     with bchk_root do
     begin
          ImageIndex := st_report;

          {Display Benchcheck required property.}
          SubItems.Add('Is benchcheck required?').RecordItems.Add(
                              cbi_yesno[Workbench.BenchcheckIndex]);
          SubItems[0].ImageIndex := st_dropdown;

          {Show Benchcheck properties if enabled.}
          if Workbench.BenchcheckIndex = 0 then begin;
             with SubItems[0] do
             begin
                  {Second level.}

                  {Display Benchcheck automatic launch property.}
                  SubItems.Add('Run benchcheck on startup.').RecordItems.Add(
                          cbi_launch[Workbench.BenchcheckLaunchIndex]);
                  SubItems[0].ImageIndex := st_dropdown;

                  {Display Benchcheck launch sub menus.}
                  if Workbench.BenchcheckLaunchIndex = 1 then begin
                     {Third level.}
                     with SubItems[0] do
                     begin
                          {Display fixed interval value property.}
                          SubItems.Add('Set fixed launch interval.').RecordItems.Add(
                                 IntToStr(Workbench.FixedInterval) + ' minute');
                          SubItems[0].ImageIndex := st_counter;
                     end;
                  end;
                  if Workbench.BenchcheckLaunchIndex = 0 then begin
                     {Third level.}
                     with SubItems[0] do
                     begin
                          {Display random interval minimum value.}
                          SubItems.Add('Minimum launch interval.').RecordItems.Add(
                                 IntToStr(Workbench.MinInterval) + ' minute');
                          SubItems[0].ImageIndex := st_counter;
                          {Display random interval maximum value.}
                          SubItems.Add('Maximum launch interval.').RecordItems.Add(
                                 IntToStr(Workbench.MaxInterval) + ' minute');
                          SubItems[1].ImageIndex := st_counter;
                     end;
                  end;


                  {Display create Benchcheck link property.}
                  SubItems.Add('Create benchcheck link.').RecordItems.Add(
                                       cbi_yesno[Workbench.BenchIconIndex]);
                  SubItems[1].ImageIndex := st_dropdown;

                  {Display create b lock windows shutdown property.}
                  SubItems.Add('Block windows shutdown.').RecordItems.Add(
                                       cbi_yesno[Settings.BlockWindowsIndex]);
                  SubItems[2].ImageIndex := st_dropdown;
             end;
          end;
     end;

     {Create catalogue root node.}
     tool_root := SettingsTreeList.Items.Add('Catalogue properties.');
     with tool_root do
     begin
          ImageIndex := st_tools;

          {Display calibration prompt property.}
          SubItems.Add('Start calibration prompting').RecordItems.Add(IntToStr(
                              Workbench.CalibrationPrompt) + ' days before due date.');
          SubItems[0].ImageIndex := st_counter;

          {Display create tool register link property.}
          SubItems.Add('Create catalogue link.').RecordItems.Add(
                               cbi_yesno[Workbench.ToolsIconIndex]);
          SubItems[1].ImageIndex := st_dropdown;

          {Display create tool register link property.}
          SubItems.Add('Run tool register on startup.').RecordItems.Add(
                               cbi_yesno[Workbench.RunToolAtStart]);
          SubItems[2].ImageIndex := st_dropdown;
     end;

     {Create application path properties root node.}
     env_root := SettingsTreeList.Items.Add('Environmental properties.');
     with env_root do
     begin
          iNumber := 0;
          ImageIndex := st_env;

          {Display and validate applications source directory, enable editing and error check.}
          SubItems.Add('Application source directory.').RecordItems.Add(Settings.RemoteDrive +
                               Settings.RemoteDirectory);
          if DirectoryExists(Settings.RemoteDrive + Settings.RemoteDirectory) then begin
             SubItems[0].ImageIndex:= st_good;
          end
          else
          begin
               SubItems[0].ImageIndex:= st_error;
               Settings.EnvStatus := false;
               Settings.EnvErrorList.Add('Invalid Application source directory.');
               Settings.ConfigFault := true;
          end;

          {Display and validate local database source directory, enable editing and error check.}
          SubItems.Add('Database source directory.').RecordItems.Add(Settings.DatabaseDrive +
                             Settings.DatabaseDir);
          if DirectoryExists(Settings.DatabaseDrive + Settings.DatabaseDir) then begin
             SubItems[1].ImageIndex:= st_good;
          end
          else
          begin
               SubItems[1].ImageIndex:= st_error;
               Settings.EnvStatus := false;
               Settings.EnvErrorList.Add('Invalid database source directory.');
               Settings.ConfigFault := true;
          end;

          {Display and validate local application directory, enable editing and error check.}
          SubItems.Add('Host cache directory.').RecordItems.Add(Settings.HostRootDrive +
                             Settings.HostAppDirectory);
          if DirectoryExists(Settings.HostRootDrive + Settings.HostAppDirectory) then begin
             SubItems[2].ImageIndex:= st_good;
          end
          else
          begin
               SubItems[2].ImageIndex:= st_error;
               Settings.EnvStatus := false;
               Settings.EnvErrorList.Add('Invalid Host cache directory.');
               Settings.ConfigFault := true;
          end;
     end;

     {Create database root node.}
     db_root := SettingsTreeList.Items.Add('Database properties.');
     with db_root do
     begin
          ImageIndex := st_db;
          {Second level.}
          SubItems.Add('Connect to database via.').RecordItems.Add(cbi_connections[
                                 Settings.SQLServerIndex]);
          SubItems[0].ImageIndex:= st_gene;

          if Settings.SQLServerIndex = 0 then begin

             {Display user database name property.}
             SubItems.Add('User database name.').RecordItems.Add(
                     Settings.CoreDB);
             if Settings.CoreDB <> '' then begin
                {Check file existance.}
                if FileExists(Settings.DatabaseDrive + Settings.DatabaseDir +
                         Settings.CoreDB) then
                begin
                     {If it does show password property.}
                     with SubItems[1] do
                     begin
                          SubItems.Add('User db password.').RecordItems.Add(
                                    Settings.CoreDBPassword);
                          SubItems[0].ImageIndex := st_pass;
                     end;
                     {Verify database connection.}
                     if Settings.CoreDBVer then
                        SubItems[1].ImageIndex := st_good
                     else
                     begin
                          if VerifyDBConnection(Settings.DatabaseDrive + Settings.DatabaseDir + Settings.CoreDB,
                             '', 'admin', Settings.CoreDBPassword, 'Microsoft Access Driver (*.mdb)') then
                          begin
                                SubItems[1].ImageIndex := st_good;
                                Settings.CoreDBVer := true;
                          end
                          else
                          begin
                               SubItems[1].ImageIndex := st_error;
                               Settings.DBStatus := false;
                               Settings.DBErrorList.Add('Cannot connect to user database.');
                               Settings.ConfigFault := true;
                               Settings.CoreDBVer := false;
                          end;
                     end;
                end
                else begin
                     SubItems[1].ImageIndex := st_error;
                     Settings.DBStatus := false;
                     Settings.DBErrorList.Add('User database file not found.');
                     Settings.ConfigFault := true;
                end;
                end else begin
                    SubItems[1].ImageIndex := st_error;
                    Settings.DBStatus := false;
                    Settings.DBErrorList.Add('User database name not set.');
                    Settings.ConfigFault := true;
                end;

                {Display benchcheck database name property.}
                SubItems.Add('Benchcheck database name.').RecordItems.Add(
                     Settings.BenchcheckDB);
                if Settings.BenchcheckDB <> '' then begin
                   {Check file existance.}
                   if FileExists(Settings.DatabaseDrive + Settings.DatabaseDir +
                         Settings.BenchcheckDB) then
                   begin
                        {If it does show password property.}
                        with SubItems[2] do
                        begin
                             SubItems.Add('Benchcheck db password.').RecordItems.Add(
                                    Settings.BenchcheckDBPassword);
                             SubItems[0].ImageIndex := st_pass;
                        end;
                        {Verify database connection.}
                        if Settings.BenchcheckDBVer then
                           SubItems[2].ImageIndex := st_good
                        else
                        begin
                             if VerifyDBConnection(Settings.DatabaseDrive + Settings.DatabaseDir + Settings.BenchcheckDB,
                                '', 'admin',  Settings.BenchcheckDBPassword, 'Microsoft Access Driver (*.mdb)') then
                             begin
                                  SubItems[2].ImageIndex := st_good;
                                  Settings.BenchcheckDBVer := true;
                             end
                             else
                             begin
                                  SubItems[2].ImageIndex := st_error;
                                  Settings.DBStatus := false;
                                  Settings.DBErrorList.Add('Cannot connect to benchcheck database.');
                                  Settings.ConfigFault := true;
                                  Settings.BenchcheckDBVer := false;
                             end;
                        end;
                   end
                   else begin
                        SubItems[2].ImageIndex := st_error;
                        Settings.DBStatus := false;
                        Settings.DBErrorList.Add('Benchcheck database file not found.');
                        Settings.ConfigFault := true;
                   end;
                end else begin
                    SubItems[2].ImageIndex := st_error;
                    Settings.DBStatus := false;
                    Settings.DBErrorList.Add('Benchcheck database name not set.');
                    Settings.ConfigFault := true;
                end;

                {Display tool register database name property.}
                SubItems.Add('Tool register database name.').RecordItems.Add(
                     Settings.ToolsDB);
                if Settings.ToolsDB <> '' then begin
                {Check file existance.}
                if FileExists(Settings.DatabaseDrive + Settings.DatabaseDir +
                         Settings.ToolsDB) then
                begin
                     {If it does show password property.}
                     with SubItems[3] do
                     begin
                          SubItems.Add('Tool register db password.').RecordItems.Add(
                                    Settings.ToolsDBPassword);
                          SubItems[0].ImageIndex := st_pass;
                     end;
                     {Verify database connection.}
                     if Settings.ToolsDBVer then
                        SubItems[3].ImageIndex := st_good
                     else
                     begin
                          if VerifyDBConnection(Settings.DatabaseDrive + Settings.DatabaseDir + Settings.ToolsDB,
                             '', 'admin',  Settings.ToolsDBPassword, 'Microsoft Access Driver (*.mdb)') then begin
                             SubItems[3].ImageIndex := st_good;
                             Settings.ToolsDBVer := true;
                          end
                          else
                          begin
                               SubItems[3].ImageIndex := st_error;
                               Settings.DBStatus := false;
                               Settings.DBErrorList.Add('Cannot connect to tool register database.');
                               Settings.ConfigFault := true;
                               Settings.ToolsDBVer := false;
                         end;
                     end;
                end
                else begin
                     SubItems[3].ImageIndex := st_error;
                     Settings.DBStatus := false;
                     Settings.DBErrorList.Add('Tool register database file not found.');
                     Settings.ConfigFault := true;
                end;
             end else begin
                 SubItems[3].ImageIndex := st_error;
                 Settings.DBStatus := false;
                 Settings.DBErrorList.Add('Tool register database name not set.');
                 Settings.ConfigFault := true;
             end;
          end;
     end;

     {Create application start settings root node.}
     app_root := SettingsTreeList.Items.Add('Application properties.');
     with app_root do
     begin
          iNumber := 0;
          ImageIndex := st_app;

          {Diplay application start location property.}
          SubItems.Add('Application start location.').RecordItems.Add(
                                    cbi_appstart[Settings.StartFromIndex]);
          SubItems[iNumber].ImageIndex:= st_dropdown;

          {Add additional properties if running from host.}
          if Settings.StartFromIndex = 1 then begin
             with SubItems[iNumber] do begin
                  {Display automatic update from source property.}
                  SubItems.Add('Auto update from source.').RecordItems.Add(
                                    cbi_yesno[Settings.AutoUpdateIndex]);
                  SubItems[0].ImageIndex := st_dropdown;
             end;
          end;

          {Diplay start application at windows start property.}
          SubItems.Add('Run on windows start.').RecordItems.Add(
                                    cbi_yesno[Settings.AutoStartIndex]);
          inc(iNumber);
          SubItems[iNumber].ImageIndex:= st_dropdown;
          {Grey desktop behind active window property.}
          SubItems.Add('Use form highlighting.').RecordItems.Add(
                            cbi_yesno[Settings.GreyScreenIndex]);
          inc(iNumber);
          SubItems[iNumber].ImageIndex:= st_dropdown;

          {Show form highlighting properties.}
          if Settings.GreyScreenIndex = 0 then begin
             with SubItems[inumber] do begin

                  {Show desktop fading property.}
                  SubItems.Add('Use screen fading.').RecordItems.Add(
                                     cbi_yesno[Settings.GreyFadeIndex]);
                  SubItems[0].ImageIndex:= st_dropdown;

                  {Show cover taskbar property.}
                  SubItems.Add('Allow taskbar access.').RecordItems.Add(
                                     cbi_yesno[Settings.GreyTaskbarIndex]);
                  SubItems[1].ImageIndex:= st_dropdown;
             end;
          end;

          {Show splash property.}
          SubItems.Add('Show splash at startup.').RecordItems.Add(
                                    cbi_yesno[Settings.ShowSplashIndex]);
          inc(iNumber);
          SubItems[iNumber].ImageIndex:= st_dropdown;
     end;



     {Finalise settings tree and update status tree.}
     SettingsTreeList.EndUpdate;

     {Is application configured on host machine}
     if ReadRegistryString(RegHKLM, RegWorkBenchSuite, ApplicationSettings) <> '' then
          Settings.HostConfigured := true
     else begin
          Settings.HostConfigured := false;
          Settings.AppStatus := false;
     end;
     if not Settings.HostConfigured then begin
        Settings.AppErrorList.Add('Registry not configured on this system.');
        Settings.ConfigFault := true;
        Settings.ConfigFault := true;
        Settings.AppStatus := false;
     end;

     {Update status tree.}
     UpdateStatusTree;
     if PageControl.ActivePage = SettingsPage then begin;
        {Display update registry button if properety change ocurred.}
        if Settings.RegistryChange then RegSaveButton.Show;
        {Display update file button if properety change ocurred.}
        if Settings.FileChange then DefaultSettingsButton.Show;
     end;
end;

{Display edit form when treelist is clicked}
procedure TMainForm.SettingsTreeListClickAtItem(sender: TObject; item: TTreeListItem);
var
   bounds              : TRect;
   iText               : string;
   LocationTemp        : array of string;
   i                   : integer = 0;
   index               : integer = 0;
begin
     HideEditControls;
     {Read item text and bounds rectangle.}
     iText := item.Text;
     bounds := item.getBounds(1);

     {Editbox clicks.}

     {Validate source directory}
     if iText = 'Application source directory.' then begin
          if DirectoryExists(Settings.RemoteDrive + Settings.RemoteDirectory) then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top),
                      (Settings.RemoteDrive + Settings.RemoteDirectory),
                      false, false, true, false);
             HelpLabel.Caption := 'Valid directory.'
          end
          else begin
               ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top),
                      (Settings.RemoteDrive + Settings.RemoteDirectory),
                      false, true, true, false);
             HelpLabel.Caption := 'Directory does not exist.';
          end;
     end;

     {Validate database directory}
     if iText = 'Database source directory.' then begin
          if DirectoryExists(Settings.DatabaseDrive + Settings.DatabaseDir) then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top),
                      (Settings.DatabaseDrive + Settings.DatabaseDir),
                      false, false, true, false);
             HelpLabel.Caption := 'Valid directory.'
          end
          else begin
               ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top),
                      (Settings.DatabaseDrive + Settings.DatabaseDir),
                      false, true, true, false);
             HelpLabel.Caption := 'Directory does not exist.';
          end;
     end;

     {Validate host application directory}
     if iText = 'Host cache directory.' then begin
          if DirectoryExists(Settings.HostRootDrive + Settings.HostAppDirectory) then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top),
                      (Settings.HostRootDrive + Settings.HostAppDirectory),
                      false, false, true, false);
             HelpLabel.Caption := 'Valid directory.'
          end
          else begin
               ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top),
                      (Settings.HostRootDrive + Settings.HostAppDirectory),
                      false, true, true, false);
               HelpLabel.Caption := 'Directory does not exist.';
          end;
     end;

     {Show Benchcheck fixed interval edit box}
     if iText = 'Set fixed launch interval.' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), IntToStr(Workbench.FixedInterval),
                      false, false, false, true);
             HelpLabel.Caption := 'Enter benchcheck fixed launch interval in minutes and press enter.';
     end;

     {Show Benchcheck minimum interval edit box}
     if iText = 'Minimum launch interval.' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), IntToStr(Workbench.MinInterval),
                      false, false, false, true);
             HelpLabel.Caption := 'Enter benchcheck minimum launch interval in minutes and press enter.';
     end;

     {Show Benchcheck maximum interval edit box}
     if iText = 'Maximum launch interval.' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), IntToStr(Workbench.MaxInterval),
                      false, false, false, true);
             HelpLabel.Caption := 'Enter benchcheck maximum launch interval in minutes and press enter.';
     end;

     {Show calibration prompt edit box}
     if iText = 'Start calibration prompting' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), IntToStr(Workbench.CalibrationPrompt),
                      false, false, false, true);
             HelpLabel.Caption := 'Enter number of days to prompt before calibartion due date and press enter.';
     end;

     {Show bench name edit box}
     if iText = 'Workbench name.' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), Workbench.BenchName,
                      false, false, false, false);
             HelpLabel.Caption := 'Enter workbench name and press enter.';
     end;

     {Show Benchcheck database name edit box.}
     if iText = 'Benchcheck database name.' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), Settings.BenchcheckDB,
                      false, false, true, false);
             HelpLabel.Caption := 'Enter benchcheck database name.';
     end;

     {Show user database name edit box.}
     if iText = 'User database name.' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), Settings.CoreDB,
                      false, false, true, false);
             HelpLabel.Caption := 'Enter User database name.';
     end;

     {Show tool register database name edit box.}
     if iText = 'Tool register database name.' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), Settings.ToolsDB,
                      false, false, true, false);
             HelpLabel.Caption := 'Enter tool register database name.';
     end;

     {Show Benchcheck db password edit box}
     if iText = 'Benchcheck db password.' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), Settings.BenchcheckDBPassWord,
                      false, false, false, false);
             HelpLabel.Caption := 'Enter benchcheck database password.';
     end;

     {Show user db  password edit box}
     if iText = 'User db password.' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), Settings.CoreDBPassword,
                      false, false, false, false);
             HelpLabel.Caption := 'Enter user database password.';
     end;

     {Show tool register password edit box}
     if iText = 'Tool register db password.' then begin
             ShowEditBox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
                      (bounds.Bottom - bounds.Top), Settings.ToolsDBPassword,
                      false, false, false, false);
             HelpLabel.Caption := 'Enter tool register database password.';
     end;

     {Combo box clicks.}

     {Display combobox for Application start location.}
     if iText = 'Application start location.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_appstart, Settings.StartFromIndex, false);
          HelpLabel.Caption := 'Select application start location.';
     end;

     {Display combobox for benchcheck icon.}
     if iText = 'Create benchcheck link.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Workbench.BenchIconIndex, false);
          HelpLabel.Caption := 'Create Benchcheck link on desktop?';
     end;

     {Display combobox for tool register icon.}
     if iText = 'Create tool register link.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Workbench.ToolsIconIndex, false);
          HelpLabel.Caption := 'Create tool register link on desktop?';
     end;

     {Display combobox for manager icon.}
     if iText = 'Create manager link.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Workbench.ManagerIconIndex, false);
          HelpLabel.Caption := 'Create workbench manager link on desktop?';
     end;

     {Display combobox for auto update from source.}
     if iText = 'Auto update from source.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Settings.AutoUpdateIndex, false);
          HelpLabel.Caption := 'Check and update from source directory?';
     end;

     {Display combobox for auto start on windows start.}
     if iText = 'Run on windows start.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Settings.AutoStartIndex, false);
          HelpLabel.Caption := 'Start application on system startup?';
     end;

     {Display combobox for grey desktop.}
     if iText = 'Use form highlighting.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Settings.GreyScreenIndex, false);
          HelpLabel.Caption := 'Grey desktop behind active window?';
     end;

     {Display combobox for fade desktop.}
     if iText = 'Use screen fading.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Settings.GreyFadeIndex, false);
          HelpLabel.Caption := 'Fade desktop behind active window?';
     end;

     {Display combobox for fade desktop.}
     if iText = 'Allow taskbar access.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Settings.GreyTaskbarIndex, false);
          HelpLabel.Caption := 'Allow taskbar access when form highlighting enabled?';
     end;

     {Display combobox for show splash.}
     if iText = 'Show splash at startup.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Settings.ShowSplashIndex, false);
          HelpLabel.Caption := 'Show splash on application start?';
     end;

     {Display combobox for bench location.}
     if iText = 'Workbench location.' then begin
          {Generate temporary array from location list.}
          SetLength(LocationTemp, Settings.BenchLocation.Count);
          for i := 0 to Settings.BenchLocation.Count - 1 do begin
              LocationTemp[i] := DecryptString(Settings.BenchLocation[i], CryptKey);
              if Settings.BenchLocation[i] = Workbench.BenchLocation then
                 index := i;
          end;

          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), LocationTemp, index, true);
          HelpLabel.Caption := 'Select workbench location.';
     end;

     {Display combobox for Benchcheck required.}
     if iText = 'Is benchcheck required?' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Workbench.BenchcheckIndex, false);
          HelpLabel.Caption := 'Is benchcheck required at this location?';
     end;

     {Display combobox for Benchcheck launch.}
     if iText = 'Run benchcheck on startup.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_launch, Workbench.BenchcheckLaunchIndex, false);
          HelpLabel.Caption := 'Select benchcheck automatic launch method.';
     end;

     {Display combobox for restrict user access default .}
     if iText = 'Restrict new user access?' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Settings.RestrictAccessDefault, false);
          HelpLabel.Caption := 'Select if new users restrictions to be applied by default.';
     end;

     {Display combobox for block windows shutdown.}
     if iText = 'Block windows shutdown.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Settings.BlockWindowsIndex, false);
          HelpLabel.Caption := 'Block windows shutdown if end of shift benchcheck not completed.';
     end;

     {Display combobox for tool register start.}
     if iText = 'Run tool register on startup.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_yesno, Workbench.RunToolAtStart, false);
          HelpLabel.Caption := 'Run tool register on application startup.';
     end;

     {Display combobox for Connect to database via.}
     if iText = 'Connect to database via.' then begin
          ShowCombobox(bounds.Top, bounds.Left, (bounds.Right - bounds.Left),
            (bounds.Bottom - bounds.Top), cbi_connections, Settings.SQLServerIndex, false);
          HelpLabel.Caption := 'Select database connection type';
     end;
end;


procedure TMainForm.CreateFolderButtonClick(Sender: TObject);
var
   item         : TTreeListItem;
   iText        : string;
   done         : boolean;
begin
     {Hide edit boxes and buttons}
     HideEditControls;
     {Get selected tree list item and read header}
     item  := SettingsTreeList.Selected;
     iText := item.Text;

     {Handle source directory create button click}
     if iText = 'Application source directory.' then
          if not DirectoryExists(Settings.RemoteDrive + Settings.RemoteDirectory) then
             done := CreateDir(Settings.RemoteDrive + Settings.RemoteDirectory);

     {Handle host application directory create button click}
     if iText = 'Host cache directory.' then
          if not DirectoryExists(Settings.HostRootDrive + Settings.HostAppDirectory) then
             done := CreateDir(Settings.HostRootDrive + Settings.HostAppDirectory);

     {Handle database directory create button click}
     if iText = 'Database source directory.' then
          if not DirectoryExists(Settings.DatabaseDrive + Settings.DatabaseDir) then
             done := CreateDir(Settings.DatabaseDrive + Settings.DatabaseDir);

     {Show status in help label.}
     if not done then
        HelpLabel.Caption := 'Unable to create folder.'
     else
        UpdateSettingsList;
end;


{Handle editbox enter key press.}
procedure TMainForm.editboxKeyPress(Sender: TObject; var Key: char);
var
   item         : TTreeListItem;
   iText        : string;
begin
     if Key = #13 then begin
        {Stop beep.}
        Key := #0;

        {Hide edit boxes and buttons}
        HideEditControls;

        {Get selected tree list item and read header}
        item  := SettingsTreeList.Selected;
        iText := item.Text;

        {Handle source directory enter key press.}
        if iText = 'Remote application directory.' then begin
           if EditBox.Text <> '' then begin
              Settings.RemoteDrive := IncludeTrailingPathDelimiter(
                  ExtractFileDrive(EditBox.Text));
              Settings.RemoteDirectory := IncludeTrailingPathDelimiter(
                  ExtractRelativePath(Settings.RemoteDrive, EditBox.Text));
              {Show save to registry and file buttons.}
              Settings.RegistryChange := true;
              Settings.FileChange := true;
           end;
        end;

        {Handle host application directory enter key press.}
        if iText = 'Host cache directory.' then begin
           if EditBox.Text <> '' then begin
              Settings.HostAppDirectory := IncludeTrailingPathDelimiter(
                  ExtractRelativePath(Settings.HostRootDrive, EditBox.Text));
              {Show save to registry and file buttons.}
              Settings.RegistryChange := true;
              Settings.FileChange := true;
           end;
        end;

        {Handle database directory enter key press.}
        if iText = 'Database source directory.' then begin
           if EditBox.Text <> '' then begin
              Settings.DatabaseDrive := IncludeTrailingPathDelimiter(
                  ExtractFileDrive(EditBox.Text));
              Settings.DatabaseDir := IncludeTrailingPathDelimiter(
                  ExtractRelativePath(Settings.DatabaseDrive, EditBox.Text));
              {Show save to registry and file buttons.}
              Settings.RegistryChange := true;
              Settings.FileChange := true;
           end;
        end;

        {Handle bench name enter key press.}
        if iText = 'Workbench name.' then begin
           if EditBox.Text <> '' then begin
              if EditBox.Text <> Workbench.BenchName then
                 Workbench.BenchName := EditBox.Text;
           end;
           {Show save to registry  button.}
           Settings.RegistryChange := true;
        end;

        {Handle benchcheck fixed interval enter key press.}
        if iText = 'Set fixed launch interval.' then begin
           if EditBox.Text <> '' then begin
              if StrToInt(EditBox.Text) <> Workbench.FixedInterval then
                 Workbench.FixedInterval := StrToInt(EditBox.Text);
           end;
           {Show save to registry  button.}
           Settings.RegistryChange := true;
        end;

        {Handle benchcheck minimum interval enter key press.}
        if iText = 'Minimum launch interval.' then begin
           if EditBox.Text <> '' then begin
              if StrToInt(EditBox.Text) <> Workbench.MinInterval then
                 Workbench.MinInterval := StrToInt(EditBox.Text);
           end;
           {Show save to registry  button.}
           Settings.RegistryChange := true;
        end;

        {Handle calibration prompt days enter key press.}
        if iText = 'Start calibration prompting' then begin
           if EditBox.Text <> '' then begin
              if StrToInt(EditBox.Text) <> Workbench.CalibrationPrompt then
                 Workbench.CalibrationPrompt := StrToInt(EditBox.Text);
           end;
           {Show save to registry  button.}
           Settings.RegistryChange := true;
        end;

        {Handle benchcheck database name enter key press.}
        if iText = 'Benchcheck database name.' then begin
           if EditBox.Text <> '' then begin
              if EditBox.Text <> Settings.BenchcheckDB then begin
                 Settings.BenchcheckDB := ExtractFileName(EditBox.Text);
                 Settings.BenchcheckDBVer := false;
                 Settings.BenchcheckDBPassword := '';
                 {Show save to registry  button.}
                 Settings.RegistryChange := true;
                 Settings.FileChange := true;
              end;
           end;
        end;

        {Handle user database name enter key press.}
        if iText = 'User database name.' then begin
           if EditBox.Text <> '' then begin
              if EditBox.Text <> Settings.CoreDB then begin
                 Settings.CoreDB := ExtractFileName(EditBox.Text);
                 Settings.CoreDBVer := false;
                 Settings.CoreDBPassword := '';
                 {Show save to registry  button.}
                 Settings.RegistryChange := true;
                 Settings.FileChange := true;
              end;
           end;
        end;

        {Handle tool register database name enter key press.}
        if iText = 'Tool register database name.' then begin
           if EditBox.Text <> '' then begin
              if EditBox.Text <> Settings.ToolsDB then begin
                 Settings.ToolsDB := ExtractFileName(EditBox.Text);
                 Settings.ToolsDBVer:= false;
                 Settings.ToolsDBPassword := '';
                 {Show save to registry  button.}
                 Settings.RegistryChange := true;
                 Settings.FileChange := true;
              end;
           end;
        end;

        {Handle benchcheck db password enter key press.}
        if iText = 'Benchcheck db password.' then begin
           if EditBox.Text <> '' then begin
              if EditBox.Text <> Settings.BenchcheckDBPassword then begin;
                 Settings.BenchcheckDBPassWord := EditBox.Text;
                 Settings.BenchcheckDBVer := false;
                 {Show save to registry  button.}
                 Settings.RegistryChange := true;
                 Settings.FileChange := true;
              end;
           end;
        end;

        {Handle user db password enter key press.}
        if iText = 'User db password.' then begin
           if EditBox.Text <> '' then begin
              if EditBox.Text <> Settings.CoreDBPassword then begin
                 Settings.CoreDBPassword := EditBox.Text;
                 Settings.CoreDBVer := false;
                 {Show save to registry  button.}
                 Settings.RegistryChange := true;
                 Settings.FileChange := true;
              end;
           end;
        end;

        {Handle tool register db password enter key press.}
        if iText = 'Tool register db password.' then begin
           if EditBox.Text <> '' then begin
              if EditBox.Text <> Settings.ToolsDBPassword then begin
                 Settings.ToolsDBPassword := EditBox.Text;
                 Settings.ToolsDBVer := false;
                 {Show save to registry  button.}
                 Settings.RegistryChange := true;
                 Settings.FileChange := true;
              end;
           end;
        end;

        {Update settings tree list.}
        UpdateSettingsList;
     end;
end;

{Open folder browser dialog box for selected tree list item}
procedure TMainForm.BrowserButtonClick(Sender: TObject);
var
   item         : TTreeListItem;
   FolderDialog : TSelectDirectoryDialog;
   FileDIalog   : TOpenDialog;
   iText        : string;
begin
     {Hide edit boxes and buttons}
     HideEditControls;

     {Get selected tree list item and read header}
     item  := SettingsTreeList.Selected;
     iText := item.Text;

     {Handle source directory button click}
     if iText = 'Application source directory.' then
     begin
          FolderDialog := TSelectDirectoryDialog.Create(nil);
          try
             FolderDialog.InitialDir := Settings.RemoteDrive + Settings.RemoteDirectory;
             if FolderDialog.Execute then
             begin
                  if IncludeTrailingPathDelimiter(ExtractFileDrive(FolderDialog.FileName)) <>
                            Settings.RemoteDrive then
                     Settings.RemoteDrive :=
                         IncludeTrailingPathDelimiter(ExtractFileDrive(FolderDialog.FileName));

                  if IncludeTrailingPathDelimiter(ExtractRelativePath(Settings.RemoteDrive,
                            FolderDialog.FileName)) <> Settings.RemoteDirectory then
                     Settings.RemoteDirectory := IncludeTrailingPathDelimiter(
                               ExtractRelativePath(Settings.RemoteDrive, FolderDialog.FileName));
                  {Show save to registry and file buttons.}
                  Settings.RegistryChange := true;
                  Settings.FileChange := true;
             end;
          finally
                 FolderDialog.Free;
          end;
     end;

     {Handle host application directory button click}
     if iText = 'Host cache directory.' then
     begin
          FolderDialog := TSelectDirectoryDialog.Create(nil);
          try
             FolderDialog.InitialDir := Settings.HostRootDrive + Settings.HostAppDirectory;
             if FolderDialog.Execute then
             begin
                  if IncludeTrailingPathDelimiter(ExtractRelativePath(Settings.HostRootDrive,
                            FolderDialog.FileName)) <> Settings.HostAppDirectory then
                     Settings.HostAppDirectory := IncludeTrailingPathDelimiter(
                               ExtractRelativePath(Settings.HostRootDrive, FolderDialog.FileName));
                  {Show save to registry and file buttons.}
                  Settings.RegistryChange := true;
                  Settings.FileChange := true;
             end;
          finally
                 FolderDialog.Free;
          end;
     end;

     {Handle database directory button click.}
     if iText = 'Database source directory.' then
     begin
          FolderDialog := TSelectDirectoryDialog.Create(nil);
          try
             FolderDialog.InitialDir := Settings.DatabaseDrive + Settings.DatabaseDir;
             if FolderDialog.Execute then
             begin
                  if IncludeTrailingPathDelimiter(ExtractFileDrive(FolderDialog.FileName)) <>
                            Settings.DatabaseDrive then
                     Settings.DatabaseDrive :=
                         IncludeTrailingPathDelimiter(ExtractFileDrive(FolderDialog.FileName));

                  if IncludeTrailingPathDelimiter(ExtractRelativePath(Settings.DatabaseDrive,
                            FolderDialog.FileName)) <> Settings.DatabaseDir then
                     Settings.DatabaseDir := IncludeTrailingPathDelimiter(
                            ExtractRelativePath(Settings.DatabaseDrive, FolderDialog.FileName));
                  {Show save to registry and file buttons.}
                  Settings.RegistryChange := true;
                  Settings.FileChange := true;
             end;
          finally
                 FolderDialog.Free;
          end;
     end;

     {Handle benchcheck database name button click.}
     if iText = 'Benchcheck database name.' then
     begin
          FileDialog := TOpenDialog.Create(nil);
          FileDialog.InitialDir:= Settings.DatabaseDrive + Settings.DatabaseDir;
          if FileDialog.Execute then begin
             if ExtractFileName(FileDialog.FileName) <> Settings.BenchcheckDB then begin
                Settings.BenchcheckDB := ExtractFileName(FileDialog.FileName);
                Settings.BenchcheckDBVer := false;
                Settings.BenchcheckDBPassword := '';
             end;
          end;
     end;

     {Handle user database name button click.}
     if iText = 'User database name.' then
     begin
          FileDialog := TOpenDialog.Create(nil);
          FileDialog.InitialDir:= Settings.DatabaseDrive + Settings.DatabaseDir;
          if FileDialog.Execute then begin
             if ExtractFileName(FileDialog.FileName) <> Settings.CoreDB then begin
                Settings.CoreDB := ExtractFileName(FileDialog.FileName);
                Settings.CoreDBVer := false;
                Settings.CoreDBPassword := '';
             end;
          end;
     end;

     {Handle tool register database name button click.}
     if iText = 'Tool register database name.' then
     begin
          FileDialog := TOpenDialog.Create(nil);
          FileDialog.InitialDir:= Settings.DatabaseDrive + Settings.DatabaseDir;
          if FileDialog.Execute then begin
             if ExtractFileName(FileDialog.FileName) <> Settings.ToolsDB then begin
                Settings.ToolsDB := ExtractFileName(FileDialog.FileName);
                Settings.ToolsDBVer := false;
                Settings.ToolsDBPassword := '';
             end;
          end;
     end;
     UpdateSettingsList;
end;

{Tree list combobox on change handler.}
procedure TMainForm.ComboBoxChange(Sender: TObject);
var
   item         : TTreeListItem;
   iText        : string;
begin
     {Hide edit boxes and buttons}
     HideEditControls;
     {Get selected tree list item and read header}
     item  := SettingsTreeList.Selected;
     iText := item.Text;
     {Handle combobox selection for Application start location.}
     if iText = 'Application start location.' then begin
          Settings.StartFromIndex := ComboBox.ItemIndex;
          {Delete desktop links.}
          if FileExists(Settings.HostRootDrive + Settings.DesktopDir + WorkbenchSuiteLink) then
              DeleteFile(PChar(Settings.HostRootDrive + Settings.DesktopDir + WorkbenchSuiteLink));

          if FileExists(Settings.HostRootDrive + Settings.DesktopDir + BenchCheckLink) then
              DeleteFile(PChar(Settings.HostRootDrive + Settings.DesktopDir + BenchCheckLink));

          if FileExists(Settings.HostRootDrive + Settings.DesktopDir + ToolRegisterLink) then
              DeleteFile(PChar(Settings.HostRootDrive + Settings.DesktopDir + ToolRegisterLink));
          {Create desktop link.}
          CreateLink;
          {Set application auto start registry value.}
          if Settings.AutoStartIndex = 0 then SetAutoStart(true);
          if Settings.AutoStartIndex = 1 then SetAutoStart(false);
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     {Handle combobox for  Benchcheck desktop icon.}
     if iText = 'Create benchcheck link.' then begin
          Workbench.BenchIconIndex := ComboBox.ItemIndex;
          {Create desktop link.}
          CreateLink;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     {Handle combobox for tool register desktop icon.}
     if iText = 'Create tool register link.' then begin
          Workbench.ToolsIconIndex := ComboBox.ItemIndex;
          {Create desktop link.}
          CreateLink;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
     end;
     {Handle combobox for manager desktop icon.}
     if iText = 'Create manager link.' then begin
          Workbench.ManagerIconIndex := ComboBox.ItemIndex;
          {Create desktop link.}
          CreateLink;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
     end;
     {Handle combobox selection for auto update.}
     if iText = 'Auto update from source.' then begin
          Settings.AutoUpdateIndex := ComboBox.ItemIndex;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     {Handle combobox selection for auto start.}
     if iText = 'Run on windows start.' then begin
          Settings.AutoStartIndex := ComboBox.ItemIndex;
          {Set application auto start registry value.}
          if Settings.AutoStartIndex = 0 then SetAutoStart(true);
          if Settings.AutoStartIndex = 1 then SetAutoStart(false);
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     {Handle combobox selection form highlighting.}
     if iText = 'Use form highlighting.' then begin
          Settings.GreyScreenIndex := ComboBox.ItemIndex;
          {Grey dekstop.}
          UpdateGreyScreen(MainForm);
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     {Handle combobox selection for fade desktop.}
     if iText = 'Use screen fading.' then begin
          Settings.GreyFadeIndex := ComboBox.ItemIndex;
          UpdateGreyScreen(MainForm);
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     {Handle combobox selection for allow taskbar access.}
     if iText = 'Allow taskbar access.' then begin
          Settings.GreyTaskbarIndex := ComboBox.ItemIndex;
          UpdateGreyScreen(MainForm);
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     {Handle combobox selection for show splash.}
     if iText = 'Show splash at startup.' then begin
          Settings.ShowSplashIndex := ComboBox.ItemIndex;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     {Handle combobox selection for bench location.}
     if iText = 'Workbench location.' then begin
          Workbench.BenchLocation := ComboBox.Text;
          {Show save to registry anbuttons.}
          Settings.RegistryChange := true;
     end;
     {Handle combobox selection for Benchcheck required.}
     if iText = 'Is benchcheck required?' then begin
          Workbench.BenchcheckIndex := ComboBox.ItemIndex;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          {Refresh desktop icons.}
          CreateLink;
     end;
     {Handle combobox selection for Benchcheck start.}
     if iText = 'Run benchcheck on startup.' then begin
          Workbench.BenchcheckLaunchIndex := ComboBox.ItemIndex;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
     end;
     {Handle combobox selection for toolcheck start.}
     if iText = 'Run tool register on startup.' then begin
          Workbench.RunToolAtStart := ComboBox.ItemIndex;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
     end;
     {Handle combobox selection for new user restrictions.}
     if iText = 'Restrict new user access?' then begin
          Settings.RestrictAccessDefault := ComboBox.ItemIndex;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     {Handle combobox selection for block windows shutdown.}
     if iText = 'Block windows shutdown.' then begin
          Settings.BlockWindowsIndex := ComboBox.ItemIndex;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     {Handle combobox selection database type selection.}
     if iText = 'Connect to database via.' then begin
          Settings.SQLServerIndex := ComboBox.ItemIndex;
          {Show save to registry and file buttons.}
          Settings.RegistryChange := true;
          Settings.FileChange := true;
     end;
     UpdateSettingsList;
end;


{Automatically configure host system.}
procedure TMainForm.AutoConfigHost;
begin

end;

{Set bench chech timer interval time or generate random number.}
procedure TMainForm.SetBenchTimer;
begin
     {Disable timer if launch never selected.}
     if Workbench.BenchcheckLaunchIndex = 2 then begin
        BenchTimer.Enabled := false;
        BenchTimer.Interval := 0;
     end;
     {Set interval and initiate timer if fixed interval selected.}
     if Workbench.BenchcheckLaunchIndex = 1 then begin
        {Set timer interval and multiply by 60000.}
        BenchTimer.Interval := Workbench.FixedInterval * MinMS;
        {Enable timer.}
        BenchTimer.Enabled := true;
     end;
     {Generate random interval between max & min intervals if random selected.}
     if Workbench.BenchcheckLaunchIndex = 0 then begin
        {Set random timer interval and multiply by 60000.}
        BenchTimer.Interval := Random((Workbench.MaxInterval * MinMS) -
           (Workbench.MinInterval * MinMS)) + (Workbench.MinInterval * MinMS);
        {Enable timer.}
        BenchTimer.Enabled := true;
     end;
end;

procedure TMainForm.ShowNewUserPage;
begin
     FirstNameEdit.Clear;
     SurnameEdit.Clear;
     NumberEdit.Clear;
     Pagecontrol.ShowTabs := false;
     Pagecontrol.ActivePage := NewUserPage;
     ExitButton.ImageIndex := 14;
     ExitButton.Hint := 'Next page';
     ExitButton.Enabled := false;
     PrevButton.Show;
     FirstNameEdit.SetFocus;
end;

procedure TMainForm.ShowScanpage;
begin
     ScanEdit.Clear;
     Pagecontrol.ShowTabs := false;
     Pagecontrol.ActivePage := ScanPage;
     ScanEdit.Text := Workbench.Password;
     ScanEdit.SetFocus;
end;

procedure TMainForm.ShowThanksPage;
begin
     Pagecontrol.ShowTabs := false;
     Pagecontrol.ActivePage := ThanksPage;
     ExitButton.Show;
end;

procedure TMainForm.ShowInfoPage;
begin
     Pagecontrol.ShowTabs := true;
     Pagecontrol.ActivePage := InfoPage;
end;

procedure TMainForm.NextPage;
begin
     PrevButton.Show;
     if Pagecontrol.ActivePage = NewUserPage then begin
        ShowScanPage;
        PrevButton.Enabled:= true;
     end
     else
     if Pagecontrol.ActivePage = ScanPage then begin
        ShowThanksPage;
        PrevButton.Enabled := true;
        ExitButton.Enabled := true;
     end
     else
     if Pagecontrol.ActivePage = ThanksPage then begin
        {Apply default user access property.}
        if Settings.RestrictAccessDefault = 0 then
           Workbench.RestrictedAccess := true
        else
           Workbench.RestrictedAccess := false;
        {Post user details to database.}
        PostUserInformation;
        if Settings.RunningAdmin then begin
           {Handle buttons.}
           ExitButton.ImageIndex := 0;
           ExitButton.Hint := 'Close';
           PrevButton.Hide;
           {Return to info page.}
           ShowInfoPage;
        end else begin
            hide;
            {Reactivate bench timer if not in admin mode}
            if Workbench.BenchcheckIndex = 0 then
               SetBenchTimer;
        end;
     end;
end;

{Reposition editbox or combobox on scroll bar chage.}
procedure TMainForm.SettingsTreeListVScrollBarChange(Sender: TObject);
var
   bounds      : TRect;
begin
     {Start update if list item selected.}
     if SettingsTreeList.Selected <> nil then begin;
        {Get selected items position.}
        bounds := SettingsTreeList.Selected.getBounds(1);
        {Hide boxes if selected item out of visible limits and restore if within limits.}
        if (bounds.Top < 21) or (bounds.Bottom > 309) then begin
           editbox.Hide;
           CreateFolderButton.Hide;
           BrowserButton.Hide;
           SearchButton.Hide;
           ComboBox.Hide;
           ListEditButton.Hide;
        end else
        begin
             {Update EditBox.}
             if EditBoxActive then begin
                EditBox.Show;
                EditBox.Top := bounds.Top + 1;
                EditBox.SetFocus;
             end;
             {Update ComboBox.}
             if ComboBoxActive then begin
                ComboBox.Show;
                ComboBox.Top := bounds.Top + 1;
             end;
             {Update CreateFolderButton.}
             if CreateFolderButtonActive then begin
                CreateFolderButton.Show;
                CreateFolderButton.Top := bounds.Top + 1;
             end;
             {Update SearchButton.}
             if SearchButtonActive then begin
                SearchButton.Show;
                SearchButton.Top := bounds.Top + 1;
             end;
             {Update BrowserButton.}
             if BrowserButtonActive then begin
                BrowserButton.Show;
                BrowserButton.Top := bounds.Top + 1;
             end;
             {Update ListEditButton.}
             if ListEditButtonActive then begin
                ListEditButton.Show;
                ListEditButton.Top := bounds.Top + 1;
             end;
        end;
     end;
end;

{Create database connections and retreive user information.}
procedure TMainForm.GetUserInformation;
begin
     {Create user database connection object.}
     if CreateUserDatabaseConnection(self) then begin
        {Set SQL search parameters and run query.}
        UserQuery.Close;
        UserQuery.SQL.Text := QSearchForUserByUserName;
        UserQuery.ParamByName('user').AsString := Workbench.Username;
        UserQuery.Open;
        {Show main form and new user details entry form if no records found, leave database connection open.}
        if UserQuery.RecordCount = 0 then begin
           {Send message to open main form.}
               Windows.SendMessageTimeout(HWND_BROADCAST, CoreMessage, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 500, Dummy);
           {Show user infomation entry form.}
           ShowUserInfo := true;
        end
        else
        begin
             {If user details then copy to user record.}
             Workbench.Firstname        := UserQuery.FieldByName('Firstname').AsString;
             Workbench.Surname          := UserQuery.FieldByName('Surname').AsString;
             Workbench.EmployeeNumber   := UserQuery.FieldByName('EmployeeNum').AsInteger;
             Workbench.Password         := UserQuery.FieldByName('UserPassword').AsString;
             Workbench.RestrictedAccess := UserQuery.FieldByName('RestrictAccess').AsBoolean;
             {Close database and free objects.}
             CloseUserConnection;
        end;
     end;
end;

procedure TMainForm.RunBenchCheck;
begin
     {Disable benchcheck times.}
     if BenchTimer.Enabled then BenchTimer.Enabled := false;
     {Create benchcheck from.}
     if not assigned(BenchcheckForm) then
        BenchcheckForm := TBenchcheckForm.Create(nil);
     Benchcheckform.Show;
     {Open bench batabase.}
     if CreateWorkbenchDatabaseConnection(self) then
     begin
        {If connection established, search for active record.}
        {Set SQL search parameters and run query.}
        WorkbenchQuery.Close;
        WorkbenchQuery.SQL.Text := QSearchForTodaysUserCheck;
        WorkbenchQuery.ParamByName('loc').AsString := Workbench.BenchName;
        WorkbenchQuery.ParamByName('uname').AsString := Workbench.Username;
        WorkbenchQuery.ParamByName('date').AsDate := Now;
        WorkbenchQuery.Open;
        {Check record count and display items.}
        if WorkbenchQuery.EOF then begin
           BenchcheckForm.PageControl.PageIndex := 0;
           BenchcheckForm.CloseButton.ImageIndex := 14;
           BenchcheckForm.CloseButton.Hint:= 'Next page.';
           BenchcheckForm.PrevButton.Hint := 'Previous page.';
           BenchcheckForm.PrevButton.ImageIndex := 16;
           BenchcheckForm.PrevButton.Show;
           BenchcheckForm.PrevButton.Enabled := false;
        end
        else begin
           if WorkbenchQuery.FieldByName('EOSComplete').AsBoolean then
                BenchcheckForm.PageControl.PageIndex := 6
           else
                BenchcheckForm.PageControl.PageIndex := 5;

           BenchcheckForm.CloseButton.ImageIndex := 0;
           BenchcheckForm.CloseButton.Hint:= 'OK.';
           BenchcheckForm.PrevButton.Hide;
        end;
        {Close database.}
        CloseWorkbenchConnection;
     end;
end;

{Post user information to datadase.}
function TMainForm.PostUserInformation: boolean;
begin
     result := true;
     {Close user query connection and set SQL.}
     UserQuery.Close;
     UserQuery.SQL.Clear;
     UserQuery.SQL.Text := QPostUserLoginDetails;
     UserQuery.Prepare;
     {Set query parameters.}
     UserQuery.ParamByName('user').AsString     := Workbench.Username;
     UserQuery.ParamByName('fname').AsString    := Workbench.Firstname;
     UserQuery.ParamByName('sname').AsString    := Workbench.Surname;
     UserQuery.ParamByName('empnum').AsInteger  := Workbench.EmployeeNumber;
     UserQuery.ParamByName('pword').AsString    := Workbench.Password;
     UserQuery.ParamByName('res').AsBoolean     := Workbench.RestrictedAccess;
     {Execute query.}
     UserQuery.ExecSQL;
     CloseUserConnection;
     {Reinitiate user login.}
     GetUserInformation;
end;



end.

